=== modified file 'TODO.txt'
--- TODO.txt	2006-09-17 14:32:05 +0000
+++ TODO.txt	2006-09-28 06:35:56 +0000
@@ -1,23 +1,23 @@
 TODO list for Olive
 -------------------
 
-[DONE] Be able to install into other locations than /usr (LarstiQ)
-[DONE] Investigate TortoiseSVN-like commit/add dialogs (LarstiQ)
-   http://samba.org/~jelmer/bzr/gcommit.png
-[DONE] HIGify the interface (Matthieu Moy)
-[DONE] Consistent placement of buttons (Matthieu Moy)
-[DONE] Display the count of pushed revisions on push (phanatic)
- - Display the commit file selector as a tree (so whole directories can be
-   toggled) (j-a-meinel)
-[DONE] "Probe location" button on the Push dialog (test write access, etc.) (ddaa)
-[DONE] Save and restore main window position and size (phanatic)
-[DONE] Real sensitive context menu - e.g. options are grey if not a branch
-   (phanatic)
-[DONE] Implement 'bzr missing' (phanatic)
- - Implement 'bzr uncommit' (phanatic)
- - Implement bundle handling - at least creating them (phanatic)
-[DONE] Testing on Windows platform (phanatic)
-[DONE] i18n/l10n with gettext (phanatic)
-[DONE] Bookmarks should have a 'title' attribute (phanatic)
-[PART-DONE] Open files on double-click, and add Open option to context menu (Aaadam)
-[DONE] Display a "No changes." text in the Status window, if tree is empty (Áron Novák)
+- Use networkmanager to figure out whether to do local or bound commits  
+  in case of bound branches/checkouts.
+- Strict commit should not be a checkbox. The GUI should rather ask the 
+  user whether (s)he wants to continue if there were no changes.
+- Commit with unknowns should not be a checkbox. The GUI should rather ask 
+  the user whether (s)he wants to continue while there were unknown files.
+- It should be possible to add unknown files from the commit dialog.
+- Generic wrapper that displays dialogs for bzr exceptions
+- Store list of previously seen branch locations and list them in 
+  a combo box in the "branch location" field in the get branch window
+- Allow selecting a particular revision (actually browsing the revisions 
+  rather than specifying a particular revno) in the get branch window
+- Eliminate radiobuttons in push but rather show the default location and 
+  allow the user to change it
+- Don't have an overwrite checkbox but instead ask the user if (s)he wants 
+  to overwrite if the branches have diverged
+- Remove the status window as it's pointless since the status is already shown
+  in the main window.
+- Is there any reason why on win32 bzr branches have to be on fixed drives and 
+  not on, e.g., cdroms?

=== modified file 'olive.glade'
--- olive.glade	2006-09-11 02:56:58 +0000
+++ olive.glade	2006-09-28 06:35:56 +0000
@@ -660,7 +660,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_commit">
+<widget class="GtkDialog" id="window_commit">
   <property name="width_request">400</property>
   <property name="height_request">400</property>
   <property name="title" translatable="yes">Olive - Commit</property>
@@ -677,10 +677,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_commit">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -894,7 +894,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_commit">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -999,7 +999,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_branch">
+<widget class="GtkDialog" id="window_branch">
   <property name="width_request">350</property>
   <property name="title" translatable="yes">Olive - Branch</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
@@ -1015,10 +1015,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_branch">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -1184,7 +1184,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_branch">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -1302,10 +1302,10 @@
   <property name="logo">oliveicon2.png</property>
 </widget>
 
-<widget class="GtkWindow" id="window_add">
+<widget class="GtkDialog" id="window_add">
   <property name="visible">True</property>
   <property name="title" translatable="yes">Olive - Add file(s)</property>
-  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="type">GTK_WINDOW_POPUP</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
   <property name="modal">False</property>
   <property name="resizable">False</property>
@@ -1318,10 +1318,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_add">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -1390,7 +1390,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_add">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -1495,7 +1495,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_remove">
+<widget class="GtkDialog" id="window_remove">
   <property name="visible">True</property>
   <property name="title" translatable="yes">Olive - Remove file(s)</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
@@ -1511,10 +1511,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_remove">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -1583,7 +1583,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_remove">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -1688,7 +1688,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_push">
+<widget class="GtkDialog" id="window_push">
   <property name="width_request">320</property>
   <property name="title" translatable="yes">Olive - Push</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
@@ -1704,10 +1704,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_push">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -1905,7 +1905,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_push">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -2023,7 +2023,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_checkout">
+<widget class="GtkDialog" id="window_checkout">
   <property name="width_request">350</property>
   <property name="title" translatable="yes">Olive - Checkout</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
@@ -2039,10 +2039,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_checkout">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -2230,7 +2230,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_checkout">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -2335,124 +2335,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_diff">
-  <property name="width_request">600</property>
-  <property name="height_request">400</property>
-  <property name="title" translatable="yes">Olive - Diff</property>
-  <property name="type">GTK_WINDOW_TOPLEVEL</property>
-  <property name="window_position">GTK_WIN_POS_NONE</property>
-  <property name="modal">False</property>
-  <property name="resizable">True</property>
-  <property name="destroy_with_parent">False</property>
-  <property name="icon">oliveicon2.png</property>
-  <property name="decorated">True</property>
-  <property name="skip_taskbar_hint">False</property>
-  <property name="skip_pager_hint">False</property>
-  <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
-  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
-  <property name="focus_on_map">True</property>
-  <property name="urgency_hint">False</property>
-
-  <child>
-    <widget class="GtkVBox" id="vbox_diff">
-      <property name="border_width">5</property>
-      <property name="visible">True</property>
-      <property name="homogeneous">False</property>
-      <property name="spacing">3</property>
-
-      <child>
-	<widget class="GtkHPaned" id="hpaned_diff">
-	  <property name="visible">True</property>
-	  <property name="can_focus">True</property>
-	  <property name="position">200</property>
-
-	  <child>
-	    <widget class="GtkScrolledWindow" id="scrolledwindow_diff_files">
-	      <property name="visible">True</property>
-	      <property name="can_focus">True</property>
-	      <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-	      <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-	      <property name="shadow_type">GTK_SHADOW_IN</property>
-	      <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
-
-	      <child>
-		<widget class="GtkTreeView" id="treeview_diff_files">
-		  <property name="visible">True</property>
-		  <property name="can_focus">True</property>
-		  <property name="headers_visible">False</property>
-		  <property name="rules_hint">False</property>
-		  <property name="reorderable">False</property>
-		  <property name="enable_search">True</property>
-		  <property name="fixed_height_mode">False</property>
-		  <property name="hover_selection">False</property>
-		  <property name="hover_expand">False</property>
-		  <signal name="cursor_changed" handler="on_treeview_diff_files_cursor_changed" last_modification_time="Thu, 03 Aug 2006 09:02:37 GMT"/>
-		</widget>
-	      </child>
-	    </widget>
-	    <packing>
-	      <property name="shrink">True</property>
-	      <property name="resize">False</property>
-	    </packing>
-	  </child>
-
-	  <child>
-	    <widget class="GtkScrolledWindow" id="scrolledwindow_diff_diff">
-	      <property name="visible">True</property>
-	      <property name="can_focus">True</property>
-	      <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-	      <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-	      <property name="shadow_type">GTK_SHADOW_IN</property>
-	      <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
-
-	      <child>
-		<placeholder/>
-	      </child>
-	    </widget>
-	    <packing>
-	      <property name="shrink">True</property>
-	      <property name="resize">True</property>
-	    </packing>
-	  </child>
-	</widget>
-	<packing>
-	  <property name="padding">0</property>
-	  <property name="expand">True</property>
-	  <property name="fill">True</property>
-	</packing>
-      </child>
-
-      <child>
-	<widget class="GtkHButtonBox" id="hbuttonbox_diff">
-	  <property name="visible">True</property>
-	  <property name="layout_style">GTK_BUTTONBOX_END</property>
-	  <property name="spacing">0</property>
-
-	  <child>
-	    <widget class="GtkButton" id="button_diff_close">
-	      <property name="visible">True</property>
-	      <property name="can_default">True</property>
-	      <property name="has_default">True</property>
-	      <property name="can_focus">True</property>
-	      <property name="label">gtk-close</property>
-	      <property name="use_stock">True</property>
-	      <property name="relief">GTK_RELIEF_NORMAL</property>
-	      <property name="focus_on_click">True</property>
-	      <signal name="clicked" handler="on_button_diff_close_clicked" last_modification_time="Wed, 02 Aug 2006 22:55:53 GMT"/>
-	    </widget>
-	  </child>
-	</widget>
-	<packing>
-	  <property name="padding">0</property>
-	  <property name="expand">False</property>
-	  <property name="fill">True</property>
-	</packing>
-      </child>
-    </widget>
-  </child>
-</widget>
-
-<widget class="GtkWindow" id="window_status">
+<widget class="GtkDialog" id="window_status">
   <property name="width_request">400</property>
   <property name="height_request">300</property>
   <property name="title" translatable="yes">Olive - Status</property>
@@ -2465,14 +2348,14 @@
   <property name="decorated">True</property>
   <property name="skip_taskbar_hint">False</property>
   <property name="skip_pager_hint">False</property>
-  <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_status">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -2507,7 +2390,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_status">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -2537,10 +2420,10 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_mkdir">
+<widget class="GtkDialog" id="window_mkdir">
   <property name="visible">True</property>
   <property name="title" translatable="yes">Olive - Make directory</property>
-  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="type">GTK_WINDOW_POPUP</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
   <property name="modal">False</property>
   <property name="resizable">True</property>
@@ -2553,10 +2436,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_mkdir">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -2600,7 +2483,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_mkdir">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -2705,10 +2588,10 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_move">
+<widget class="GtkDialog" id="window_move">
   <property name="width_request">250</property>
   <property name="title" translatable="yes">Olive - Move</property>
-  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="type">GTK_WINDOW_POPUP</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
   <property name="modal">False</property>
   <property name="resizable">True</property>
@@ -2721,10 +2604,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_move">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -2889,7 +2772,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_rename">
+<widget class="GtkDialog" id="window_rename">
   <property name="title" translatable="yes">Olive - Rename</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
@@ -2904,10 +2787,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_rename">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -3075,7 +2958,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_info">
+<widget class="GtkDialog" id="window_info">
   <property name="title" translatable="yes">Olive - Information</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
@@ -3090,10 +2973,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_info">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -5343,7 +5226,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_info">
 	  <property name="visible">True</property>
 	  <property name="can_default">True</property>
@@ -5375,7 +5258,7 @@
   </child>
 </widget>
 
-<widget class="GtkWindow" id="window_bookmark">
+<widget class="GtkDialog" id="window_bookmark">
   <property name="visible">True</property>
   <property name="title" translatable="yes">Edit bookmark - Olive</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
@@ -5391,10 +5274,10 @@
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
+  <property name="has_separator">True</property>
 
-  <child>
+  <child internal-child="vbox">
     <widget class="GtkVBox" id="vbox_bookmark">
-      <property name="border_width">5</property>
       <property name="visible">True</property>
       <property name="homogeneous">False</property>
       <property name="spacing">3</property>
@@ -5514,7 +5397,7 @@
 	</packing>
       </child>
 
-      <child>
+      <child internal-child="action_area">
 	<widget class="GtkHButtonBox" id="hbuttonbox_bookmark">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
@@ -5556,5 +5439,4 @@
     </widget>
   </child>
 </widget>
-
 </glade-interface>

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2006-09-25 01:58:44 +0000
+++ olive/__init__.py	2006-09-28 06:35:56 +0000
@@ -14,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import ConfigParser
 import os
 import os.path
 import sys
@@ -24,81 +23,120 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.gdk
-    import gtk.glade
-except:
-    sys.exit(1)
+import gtk
+import gtk.gdk
+import gtk.glade
 
-from handler import OliveHandler
 import bzrlib.errors as errors
+from bzrlib.workingtree import WorkingTree
 
 # Olive GTK UI version
 __version__ = '0.11.0'
 
+# Load the glade file
+if sys.platform == 'win32':
+    gladefile = os.path.dirname(sys.executable) + "/share/olive/olive.glade"
+else:
+    gladefile = "/usr/share/olive/olive.glade"
+
+if not os.path.exists(gladefile):
+    # Load from current directory if not installed
+    gladefile = "olive.glade"
+    # Check again
+    if not os.path.exists(gladefile):
+        # Fail
+        print _('Glade file cannot be found.')
+        sys.exit(1)
+
 class OliveGtk:
     """ The main Olive GTK frontend class. This is called when launching the
     program. """
     
     def __init__(self):
-        # Load the glade file
-        if sys.platform == 'win32':
-            self.gladefile = os.path.dirname(sys.executable) + "/share/olive/olive.glade"
-        else:
-            self.gladefile = "/usr/share/olive/olive.glade"
-
-        if not os.path.exists(self.gladefile):
-            # Load from current directory if not installed
-            self.gladefile = "olive.glade"
-            # Check again
-            if not os.path.exists(self.gladefile):
-                # Fail
-                print _('Glade file cannot be found.')
-                sys.exit(1)
-
-        self.toplevel = gtk.glade.XML(self.gladefile, 'window_main', 'olive-gtk')
+        self.toplevel = gtk.glade.XML(gladefile, 'window_main', 'olive-gtk')
         
         self.window = self.toplevel.get_widget('window_main')
         
         self.pref = OlivePreferences()
-        self.comm = OliveCommunicator(self.toplevel, self.pref)
-        handler = OliveHandler(self.gladefile, self.comm)
+
+        # Initialize the statusbar
+        self.statusbar = self.toplevel.get_widget('statusbar')
+        self.context_id = self.statusbar.get_context_id('olive')
+        
+        # Get the main window
+        self.window_main = self.toplevel.get_widget('window_main')
+        # Get the HPaned
+        self.hpaned_main = self.toplevel.get_widget('hpaned_main')
+        # Get the TreeViews
+        self.treeview_left = self.toplevel.get_widget('treeview_left')
+        self.treeview_right = self.toplevel.get_widget('treeview_right')
+        # Get some important menu items
+        self.menuitem_add_files = self.toplevel.get_widget('menuitem_add_files')
+        self.menuitem_remove_files = self.toplevel.get_widget('menuitem_remove_file')
+        self.menuitem_file_make_directory = self.toplevel.get_widget('menuitem_file_make_directory')
+        self.menuitem_file_rename = self.toplevel.get_widget('menuitem_file_rename')
+        self.menuitem_file_move = self.toplevel.get_widget('menuitem_file_move')
+        self.menuitem_view_show_hidden_files = self.toplevel.get_widget('menuitem_view_show_hidden_files')
+        self.menuitem_branch = self.toplevel.get_widget('menuitem_branch')
+        self.menuitem_branch_init = self.toplevel.get_widget('menuitem_branch_initialize')
+        self.menuitem_branch_get = self.toplevel.get_widget('menuitem_branch_get')
+        self.menuitem_branch_checkout = self.toplevel.get_widget('menuitem_branch_checkout')
+        self.menuitem_branch_pull = self.toplevel.get_widget('menuitem_branch_pull')
+        self.menuitem_branch_push = self.toplevel.get_widget('menuitem_branch_push')
+        self.menuitem_branch_commit = self.toplevel.get_widget('menuitem_branch_commit')
+        self.menuitem_branch_status = self.toplevel.get_widget('menuitem_branch_status')
+        self.menuitem_branch_missing = self.toplevel.get_widget('menuitem_branch_missing_revisions')
+        self.menuitem_stats = self.toplevel.get_widget('menuitem_stats')
+        self.menuitem_stats_diff = self.toplevel.get_widget('menuitem_stats_diff')
+        self.menuitem_stats_log = self.toplevel.get_widget('menuitem_stats_log')
+        # Get some toolbuttons
+        #self.menutoolbutton_diff = self.toplevel.get_widget('menutoolbutton_diff')
+        self.toolbutton_diff = self.toplevel.get_widget('toolbutton_diff')
+        self.toolbutton_log = self.toplevel.get_widget('toolbutton_log')
+        self.toolbutton_commit = self.toplevel.get_widget('toolbutton_commit')
+        self.toolbutton_pull = self.toplevel.get_widget('toolbutton_pull')
+        self.toolbutton_push = self.toplevel.get_widget('toolbutton_push')
+        # Get the drive selector
+        self.combobox_drive = gtk.combo_box_new_text()
+        self.combobox_drive.connect("changed", self._refresh_drives)
+        
+        self.vbox_main_right = self.toplevel.get_widget('vbox_main_right')
+ 
         
         # Dictionary for signal_autoconnect
         dic = { "on_window_main_destroy": gtk.main_quit,
-                "on_window_main_delete_event": handler.on_window_main_delete_event,
-                "on_quit_activate": handler.on_window_main_delete_event,
-                "on_about_activate": handler.on_about_activate,
-                "on_menuitem_add_files_activate": handler.on_menuitem_add_files_activate,
-                "on_menuitem_remove_file_activate": handler.on_menuitem_remove_file_activate,
-                "on_menuitem_file_make_directory_activate": handler.on_menuitem_file_make_directory_activate,
-                "on_menuitem_file_move_activate": handler.on_menuitem_file_move_activate,
-                "on_menuitem_file_rename_activate": handler.on_menuitem_file_rename_activate,
-                "on_menuitem_view_show_hidden_files_activate": handler.on_menuitem_view_show_hidden_files_activate,
-                "on_menuitem_view_refresh_activate": handler.on_menuitem_view_refresh_activate,
-                "on_menuitem_branch_initialize_activate": handler.on_menuitem_branch_initialize_activate,
-                "on_menuitem_branch_get_activate": handler.on_menuitem_branch_get_activate,
-                "on_menuitem_branch_checkout_activate": handler.on_menuitem_branch_checkout_activate,
-                "on_menuitem_branch_commit_activate": handler.on_menuitem_branch_commit_activate,
-                "on_menuitem_branch_push_activate": handler.on_menuitem_branch_push_activate,
-                "on_menuitem_branch_pull_activate": handler.on_menuitem_branch_pull_activate,
-                "on_menuitem_branch_status_activate": handler.on_menuitem_branch_status_activate,
-                "on_menuitem_branch_missing_revisions_activate": handler.on_menuitem_branch_missing_revisions_activate,
-                "on_menuitem_stats_diff_activate": handler.on_menuitem_stats_diff_activate,
-                "on_menuitem_stats_log_activate": handler.on_menuitem_stats_log_activate,
-                "on_menuitem_stats_infos_activate": handler.on_menuitem_stats_infos_activate,
-                "on_toolbutton_refresh_clicked": handler.on_menuitem_view_refresh_activate,
-                "on_toolbutton_log_clicked": handler.on_menuitem_stats_log_activate,
-                #"on_menutoolbutton_diff_clicked": handler.on_menuitem_stats_diff_activate,
-                "on_toolbutton_diff_clicked": handler.on_menuitem_stats_diff_activate,
-                "on_toolbutton_commit_clicked": handler.on_menuitem_branch_commit_activate,
-                "on_toolbutton_pull_clicked": handler.on_menuitem_branch_pull_activate,
-                "on_toolbutton_push_clicked": handler.on_menuitem_branch_push_activate,
-                "on_treeview_right_button_press_event": handler.on_treeview_right_button_press_event,
-                "on_treeview_right_row_activated": handler.on_treeview_right_row_activated,
-                "on_treeview_left_button_press_event": handler.on_treeview_left_button_press_event,
-                "on_treeview_left_row_activated": handler.on_treeview_left_row_activated }
+                "on_window_main_delete_event": self.on_window_main_delete_event,
+                "on_quit_activate": self.on_window_main_delete_event,
+                "on_about_activate": self.on_about_activate,
+                "on_menuitem_add_files_activate": self.on_menuitem_add_files_activate,
+                "on_menuitem_remove_file_activate": self.on_menuitem_remove_file_activate,
+                "on_menuitem_file_make_directory_activate": self.on_menuitem_file_make_directory_activate,
+                "on_menuitem_file_move_activate": self.on_menuitem_file_move_activate,
+                "on_menuitem_file_rename_activate": self.on_menuitem_file_rename_activate,
+                "on_menuitem_view_show_hidden_files_activate": self.on_menuitem_view_show_hidden_files_activate,
+                "on_menuitem_view_refresh_activate": self.on_menuitem_view_refresh_activate,
+                "on_menuitem_branch_initialize_activate": self.on_menuitem_branch_initialize_activate,
+                "on_menuitem_branch_get_activate": self.on_menuitem_branch_get_activate,
+                "on_menuitem_branch_checkout_activate": self.on_menuitem_branch_checkout_activate,
+                "on_menuitem_branch_commit_activate": self.on_menuitem_branch_commit_activate,
+                "on_menuitem_branch_push_activate": self.on_menuitem_branch_push_activate,
+                "on_menuitem_branch_pull_activate": self.on_menuitem_branch_pull_activate,
+                "on_menuitem_branch_status_activate": self.on_menuitem_branch_status_activate,
+                "on_menuitem_branch_missing_revisions_activate": self.on_menuitem_branch_missing_revisions_activate,
+                "on_menuitem_stats_diff_activate": self.on_menuitem_stats_diff_activate,
+                "on_menuitem_stats_log_activate": self.on_menuitem_stats_log_activate,
+                "on_menuitem_stats_infos_activate": self.on_menuitem_stats_infos_activate,
+                "on_toolbutton_refresh_clicked": self.on_menuitem_view_refresh_activate,
+                "on_toolbutton_log_clicked": self.on_menuitem_stats_log_activate,
+                #"on_menutoolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
+                "on_toolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
+                "on_toolbutton_commit_clicked": self.on_menuitem_branch_commit_activate,
+                "on_toolbutton_pull_clicked": self.on_menuitem_branch_pull_activate,
+                "on_toolbutton_push_clicked": self.on_menuitem_branch_push_activate,
+                "on_treeview_right_button_press_event": self.on_treeview_right_button_press_event,
+                "on_treeview_right_row_activated": self.on_treeview_right_row_activated,
+                "on_treeview_left_button_press_event": self.on_treeview_left_button_press_event,
+                "on_treeview_left_row_activated": self.on_treeview_left_row_activated }
         
         # Connect the signals to the handlers
         self.toplevel.signal_autoconnect(dic)
@@ -112,7 +150,7 @@
         self.window.move(x, y)
         # Apply paned position
         pos = self.pref.get_preference('paned_position', 'int')
-        self.comm.hpaned_main.set_position(pos)
+        self.hpaned_main.set_position(pos)
         
         # Apply menu to the toolbutton
         #menubutton = self.toplevel.get_widget('menutoolbutton_diff')
@@ -123,35 +161,304 @@
         
         # Show drive selector if under Win32
         if sys.platform == 'win32':
-            self.comm.vbox_main_right.pack_start(self.comm.combobox_drive, False, True, 0)
-            self.comm.vbox_main_right.reorder_child(self.comm.combobox_drive, 0)
-            self.comm.combobox_drive.show()
-            self.comm.gen_hard_selector()
+            self.vbox_main_right.pack_start(self.combobox_drive, False, True, 0)
+            self.vbox_main_right.reorder_child(self.combobox_drive, 0)
+            self.combobox_drive.show()
+            self.gen_hard_selector()
         
         # Load default data into the panels
         self.treeview_left = self.toplevel.get_widget('treeview_left')
         self.treeview_right = self.toplevel.get_widget('treeview_right')
         self._load_left()
+
+        # Apply menu state
+        self.menuitem_view_show_hidden_files.set_active(self.pref.get_preference('dotted_files', 'bool'))
+
+        self.set_path(os.getcwd())
+
+    def set_path(self, path):
+        self.path = path
+        self.notbranch = False
+        try:
+            self.wt, self.wtpath = WorkingTree.open_containing(self.path)
+        except NotBranchError:
+            self.notbranch = True
         self._load_right()
 
-        # Apply menu state
-        self.comm.menuitem_view_show_hidden_files.set_active(self.pref.get_preference('dotted_files', 'bool'))
+    def get_path(self):
+        return self.path
+   
+    def on_about_activate(self, widget):
+        about()
+        
+    def on_menuitem_add_files_activate(self, widget):
+        """ Add file(s)... menu handler. """
+        from add import OliveAdd
+        add = OliveAdd(self.wt, self.wtpath, self.get_selected_right())
+        add.display()
+    
+    def on_menuitem_branch_get_activate(self, widget):
+        """ Branch/Get... menu handler. """
+        from branch import OliveBranch
+        branch = OliveBranch()
+        branch.display()
+    
+    def on_menuitem_branch_checkout_activate(self, widget):
+        """ Branch/Checkout... menu handler. """
+        from checkout import OliveCheckout
+        checkout = OliveCheckout()
+        checkout.display()
+    
+    def on_menuitem_branch_commit_activate(self, widget):
+        """ Branch/Commit... menu handler. """
+        from commit import OliveCommit
+        commit = OliveCommit(self.wt, self.wtpath)
+        commit.display()
+    
+    def on_menuitem_branch_missing_revisions_activate(self, widget):
+        """ Branch/Missing revisions menu handler. """
+        
+        import bzrlib
+        
+        local_branch = self.wt.branch
+        
+        other_branch = local_branch.get_parent()
+        if other_branch is None:
+            error_dialog(_('Parent location is unknown'),
+                                     _('Cannot determine missing revisions if no parent location is known.'))
+            return
+        
+        remote_branch = Branch.open(other_branch)
+        
+        if remote_branch.base == local_branch.base:
+            remote_branch = local_branch
+
+        ret = len(local_branch.missing_revisions(remote_branch))
+
+        if ret > 0:
+            info_dialog(_('There are missing revisions'),
+                                    _('%d revision(s) missing.') % ret)
+        else:
+            info_dialog(_('Local branch up to date'),
+                                    _('There are no missing revisions.'))
+
+    def on_menuitem_branch_pull_activate(self, widget):
+        """ Branch/Pull menu handler. """
+        
+        branch_to = self.wt.branch
+
+        location = branch_to.get_parent()
+        if location is None:
+            error_dialog(_('Parent location is unknown'),
+                                     _('Pulling is not possible until there is a parent location.'))
+            return
+
+        try:
+            branch_from = Branch.open(location)
+        except errors.NotBranchError:
+            error_dialog(_('Directory is not a branch'),
+                                     _('You can perform this action only in a branch.'))
+
+        if branch_to.get_parent() is None:
+            branch_to.set_parent(branch_from.base)
+
+        old_rh = branch_to.revision_history()
+        if tree_to is not None:
+            tree_to.pull(branch_from)
+        else:
+            branch_to.pull(branch_from)
+        
+        info_dialog(_('Pull successful'), _('%d revision(s) pulled.') % ret)
+    
+    def on_menuitem_branch_push_activate(self, widget):
+        """ Branch/Push... menu handler. """
+        from push import OlivePush
+        push = OlivePush(self.wt.branch)
+        push.display()
+    
+    def on_menuitem_branch_status_activate(self, widget):
+        """ Branch/Status... menu handler. """
+        from status import OliveStatus
+        status = OliveStatus(self.wt, self.wtpath)
+        status.display()
+    
+    def on_menuitem_branch_initialize_activate(self, widget):
+        """ Initialize current directory. """
+        try:
+            if not os.path.exists(self.path):
+                os.mkdir(self.path)
+     
+            try:
+                existing_bzrdir = bzrdir.BzrDir.open(self.path)
+            except NotBranchError:
+                bzrdir.BzrDir.create_branch_convenience(self.path)
+            else:
+                if existing_bzrdir.has_branch():
+                    if existing_bzrdir.has_workingtree():
+                        raise AlreadyBranchError(self.path)
+                    else:
+                        raise BranchExistsWithoutWorkingTree(self.path)
+                else:
+                    existing_bzrdir.create_branch()
+                    existing_bzrdir.create_workingtree()
+        except errors.AlreadyBranchError, errmsg:
+            error_dialog(_('Directory is already a branch'),
+                                     _('The current directory (%s) is already a branch.\nYou can start using it, or initialize another directory.') % errmsg)
+        except errors.BranchExistsWithoutWorkingTree, errmsg:
+            error_dialog(_('Branch without a working tree'),
+                                     _('The current directory (%s)\nis a branch without a working tree.') % errmsg)
+        else:
+            info_dialog(_('Initialize successful'),
+                                    _('Directory successfully initialized.'))
+            self.refresh_right()
+        
+    def on_menuitem_file_make_directory_activate(self, widget):
+        """ File/Make directory... menu handler. """
+        from mkdir import OliveMkdir
+        mkdir = OliveMkdir(self.wt, self.wtpath)
+        mkdir.display()
+    
+    def on_menuitem_file_move_activate(self, widget):
+        """ File/Move... menu handler. """
+        from move import OliveMove
+        move = OliveMove(self.wt, self.wtpath, self.get_selected_right())
+        move.display()
+    
+    def on_menuitem_file_rename_activate(self, widget):
+        """ File/Rename... menu handler. """
+        from rename import OliveRename
+        rename = OliveRename(self.wt, self.wtpath, self.get_selected_right())
+        rename.display()
+
+    def on_menuitem_remove_file_activate(self, widget):
+        """ Remove (unversion) selected file. """
+        from remove import OliveRemove
+        remove = OliveRemove(self.wt, self.wtpath, self.get_selected_right())
+        remove.display()
+    
+    def on_menuitem_stats_diff_activate(self, widget):
+        """ Statistics/Differences... menu handler. """
+        from bzrlib.plugins.gtk.viz.diffwin import DiffWindow
+        window = DiffWindow()
+        parent_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
+        window.set_diff(self.wt.branch.nick, self.wt, parent_tree)
+        window.show()
+    
+    def on_menuitem_stats_infos_activate(self, widget):
+        """ Statistics/Informations... menu handler. """
+        from info import OliveInfo
+        info = OliveInfo(self.wt)
+        info.display()
+    
+    def on_menuitem_stats_log_activate(self, widget):
+        """ Statistics/Log... menu handler. """
+        from bzrlib.plugins.gtk.viz.branchwin import BranchWindow
+        window = BranchWindow()
+        window.set_branch(self.wt.branch, self.wt.branch.last_revision(), None)
+        window.show()
+    
+    def on_menuitem_view_refresh_activate(self, widget):
+        """ View/Refresh menu handler. """
+        # Refresh the left pane
+        self.refresh_left()
+        # Refresh the right pane
+        self.refresh_right()
+
+   
+    def on_menuitem_view_show_hidden_files_activate(self, widget):
+        """ View/Show hidden files menu handler. """
+        self.set_preference('dotted_files', widget.get_active())
+
+    def on_treeview_left_button_press_event(self, widget, event):
+        """ Occurs when somebody right-clicks in the bookmark list. """
+        if event.button == 3:
+            # Don't show context with nothing selected
+            if self.get_selected_left() == None:
+                return
+
+            self.menu.left_context_menu().popup(None, None, None, 0,
+                                                event.time)
+        
+    def on_treeview_left_row_activated(self, treeview, path, view_column):
+        """ Occurs when somebody double-clicks or enters an item in the
+        bookmark list. """
+
+        newdir = self.get_selected_left()
+        if newdir == None:
+            return
+
+        self.set_path(newdir)
+        self.refresh_right()
+    
+    def on_treeview_right_button_press_event(self, widget, event):
+        """ Occurs when somebody right-clicks in the file list. """
+        if event.button == 3:
+            # get the menu items
+            m_add = self.menu.ui.get_widget('/context_right/add')
+            m_remove = self.menu.ui.get_widget('/context_right/remove')
+            m_commit = self.menu.ui.get_widget('/context_right/commit')
+            m_diff = self.menu.ui.get_widget('/context_right/diff')
+            # check if we're in a branch
+            try:
+                from bzrlib.branch import Branch
+                Branch.open_containing(self.get_path())
+                m_add.set_sensitive(False)
+                m_remove.set_sensitive(False)
+                m_commit.set_sensitive(False)
+                m_diff.set_sensitive(False)
+            except errors.NotBranchError:
+                m_add.set_sensitive(True)
+                m_remove.set_sensitive(True)
+                m_commit.set_sensitive(True)
+                m_diff.set_sensitive(True)
+            self.menu.right_context_menu().popup(None, None, None, 0,
+                                                 event.time)
+        
+    def on_treeview_right_row_activated(self, treeview, path, view_column):
+        """ Occurs when somebody double-clicks or enters an item in the
+        file list. """
+        import os.path
+        
+        newdir = self.get_selected_right()
+        
+        if newdir == '..':
+            self.set_path(os.path.split(self.get_path())[0])
+        else:
+            fullpath = self.get_path() + os.sep + newdir
+            if os.path.isdir(fullpath):
+                # selected item is an existant directory
+                self.set_path(fullpath)
+            else:
+                launch(fullpath) 
+        
+        self.refresh_right()
+    
+    def on_window_main_delete_event(self, widget, event=None):
+        """ Do some stuff before exiting. """
+        width, height = self.window_main.get_size()
+        self.pref.set_preference('window_width', width)
+        self.pref.set_preference('window_height', height)
+        x, y = self.window_main.get_position()
+        self.pref.set_preference('window_x', x)
+        self.pref.set_preference('window_y', y)
+        self.pref.set_preference('paned_position',
+                                      self.hpaned_main.get_position())
+        
+        self.pref.write()
+        self.window_main.destroy()
         
     def _load_left(self):
         """ Load data into the left panel. (Bookmarks) """
-        # set cursor to busy
-        self.comm.set_busy(self.treeview_left)
-        
         # Create TreeStore
         treestore = gtk.TreeStore(str, str)
         
         # Get bookmarks
-        bookmarks = self.comm.pref.get_bookmarks()
+        bookmarks = self.pref.get_bookmarks()
         
         # Add them to the TreeStore
         titer = treestore.append(None, [_('Bookmarks'), None])
         for item in bookmarks:
-            title = self.comm.pref.get_bookmark_title(item)
+            title = self.pref.get_bookmark_title(item)
             treestore.append(titer, [title, item])
         
         # Create the column and add it to the TreeView
@@ -167,15 +474,8 @@
         # Expand the tree
         self.treeview_left.expand_all()
 
-        self.comm.set_busy(self.treeview_left, False)
-        
     def _load_right(self):
         """ Load data into the right panel. (Filelist) """
-        from bzrlib.workingtree import WorkingTree
-        
-        # set cursor to busy
-        self.comm.set_busy(self.treeview_right)
-        
         # Create ListStore
         liststore = gtk.ListStore(str, str, str)
         
@@ -183,12 +483,11 @@
         files = []
         
         # Fill the appropriate lists
-        path = self.comm.get_path()
         dotted_files = self.pref.get_preference('dotted_files', 'bool')
-        for item in os.listdir(path):
+        for item in os.listdir(self.path):
             if not dotted_files and item[0] == '.':
                 continue
-            if os.path.isdir(path + os.sep + item):
+            if os.path.isdir(self.path + os.sep + item):
                 dirs.append(item)
             else:
                 files.append(item)
@@ -197,28 +496,19 @@
         dirs.sort()
         files.sort()
         
-        # Try to open the working tree
-        notbranch = False
-        try:
-            tree1 = WorkingTree.open_containing(path)[0]
-        except errors.NotBranchError:
-            notbranch = True
-        except errors.PermissionDenied:
-            print "DEBUG: permission denied."
-        
-        if not notbranch:
-            branch = tree1.branch
-            tree2 = tree1.branch.repository.revision_tree(branch.last_revision())
-        
-            delta = tree1.changes_from(tree2, want_unchanged=True)
+        if not self.notbranch:
+            branch = self.wt.branch
+            tree2 = self.wt.branch.repository.revision_tree(branch.last_revision())
+        
+            delta = self.wt.changes_from(tree2, want_unchanged=True)
         
         # Add'em to the ListStore
         for item in dirs:    
             liststore.append([gtk.STOCK_DIRECTORY, item, ''])
         for item in files:
             status = 'unknown'
-            if not notbranch:
-                filename = tree1.relpath(path + os.sep + item)
+            if not self.notbranch:
+                filename = self.wt.relpath(self.path + os.sep + item)
                 
                 for rpath, id, kind, text_modified, meta_modified in delta.renamed:
                     if rpath == filename:
@@ -226,7 +516,7 @@
                 for rpath, id, kind in delta.added:
                     if rpath == filename:
                         status = 'added'
-                for rpath, id, kind, text_modified, meta_modified in delta.removed:
+                for rpath, id, kind in delta.removed:
                     if rpath == filename:
                         status = 'removed'
                 for rpath, id, kind, text_modified, meta_modified in delta.modified:
@@ -271,118 +561,29 @@
         tvcolumn_filename.add_attribute(cell, 'text', 1)
         tvcolumn_status.pack_start(cell, True)
         tvcolumn_status.add_attribute(cell, 'text', 2)
-        
+
+        self.menuitem_branch_init.set_sensitive(self.notbranch)
         # Check if current directory is a branch
-        if not notbranch:
-            # Activate some items
-            self.comm.menuitem_branch_init.set_sensitive(False)
-            self.comm.menuitem_branch_get.set_sensitive(True)
-            self.comm.menuitem_branch_checkout.set_sensitive(True)
-            self.comm.menuitem_branch_pull.set_sensitive(True)
-            self.comm.menuitem_branch_push.set_sensitive(True)
-            self.comm.menuitem_branch_commit.set_sensitive(True)
-            self.comm.menuitem_branch_status.set_sensitive(True)
-            self.comm.menuitem_branch_missing.set_sensitive(True)
-            self.comm.menuitem_stats.set_sensitive(True)
-            self.comm.menuitem_add_files.set_sensitive(True)
-            self.comm.menuitem_remove_files.set_sensitive(True)
-            self.comm.menuitem_file_make_directory.set_sensitive(True)
-            self.comm.menuitem_file_rename.set_sensitive(True)
-            self.comm.menuitem_file_move.set_sensitive(True)
-            #self.comm.menutoolbutton_diff.set_sensitive(True)
-            self.comm.toolbutton_diff.set_sensitive(True)
-            self.comm.toolbutton_log.set_sensitive(True)
-            self.comm.toolbutton_commit.set_sensitive(True)
-            self.comm.toolbutton_pull.set_sensitive(True)
-            self.comm.toolbutton_push.set_sensitive(True)
-        else:
-            # Deactivate some items
-            self.comm.menuitem_branch_init.set_sensitive(True)
-            self.comm.menuitem_branch_get.set_sensitive(False)
-            self.comm.menuitem_branch_checkout.set_sensitive(False)
-            self.comm.menuitem_branch_pull.set_sensitive(False)
-            self.comm.menuitem_branch_push.set_sensitive(False)
-            self.comm.menuitem_branch_commit.set_sensitive(False)
-            self.comm.menuitem_branch_status.set_sensitive(False)
-            self.comm.menuitem_branch_missing.set_sensitive(False)
-            self.comm.menuitem_stats.set_sensitive(False)
-            self.comm.menuitem_add_files.set_sensitive(False)
-            self.comm.menuitem_remove_files.set_sensitive(False)
-            self.comm.menuitem_file_make_directory.set_sensitive(False)
-            self.comm.menuitem_file_rename.set_sensitive(False)
-            self.comm.menuitem_file_move.set_sensitive(False)
-            #self.comm.menutoolbutton_diff.set_sensitive(False)
-            self.comm.toolbutton_diff.set_sensitive(False)
-            self.comm.toolbutton_log.set_sensitive(False)
-            self.comm.toolbutton_commit.set_sensitive(False)
-            self.comm.toolbutton_pull.set_sensitive(False)
-            self.comm.toolbutton_push.set_sensitive(False)
-        
-        # set cursor to default
-        self.comm.set_busy(self.treeview_right, False)
-
-class OliveCommunicator:
-    """ This class is responsible for the communication between the different
-    modules. """
-    def __init__(self, toplevel, pref):
-        # Get glade main component
-        self.toplevel = toplevel
-        # Preferences object
-        self.pref = pref
-        # Default path
-        self._path = os.getcwd()
-
-        # Initialize the statusbar
-        self.statusbar = self.toplevel.get_widget('statusbar')
-        self.context_id = self.statusbar.get_context_id('olive')
-        
-        # Get the main window
-        self.window_main = self.toplevel.get_widget('window_main')
-        # Get the HPaned
-        self.hpaned_main = self.toplevel.get_widget('hpaned_main')
-        # Get the TreeViews
-        self.treeview_left = self.toplevel.get_widget('treeview_left')
-        self.treeview_right = self.toplevel.get_widget('treeview_right')
-        # Get some important menu items
-        self.menuitem_add_files = self.toplevel.get_widget('menuitem_add_files')
-        self.menuitem_remove_files = self.toplevel.get_widget('menuitem_remove_file')
-        self.menuitem_file_make_directory = self.toplevel.get_widget('menuitem_file_make_directory')
-        self.menuitem_file_rename = self.toplevel.get_widget('menuitem_file_rename')
-        self.menuitem_file_move = self.toplevel.get_widget('menuitem_file_move')
-        self.menuitem_view_show_hidden_files = self.toplevel.get_widget('menuitem_view_show_hidden_files')
-        self.menuitem_branch = self.toplevel.get_widget('menuitem_branch')
-        self.menuitem_branch_init = self.toplevel.get_widget('menuitem_branch_initialize')
-        self.menuitem_branch_get = self.toplevel.get_widget('menuitem_branch_get')
-        self.menuitem_branch_checkout = self.toplevel.get_widget('menuitem_branch_checkout')
-        self.menuitem_branch_pull = self.toplevel.get_widget('menuitem_branch_pull')
-        self.menuitem_branch_push = self.toplevel.get_widget('menuitem_branch_push')
-        self.menuitem_branch_commit = self.toplevel.get_widget('menuitem_branch_commit')
-        self.menuitem_branch_status = self.toplevel.get_widget('menuitem_branch_status')
-        self.menuitem_branch_missing = self.toplevel.get_widget('menuitem_branch_missing_revisions')
-        self.menuitem_stats = self.toplevel.get_widget('menuitem_stats')
-        self.menuitem_stats_diff = self.toplevel.get_widget('menuitem_stats_diff')
-        self.menuitem_stats_log = self.toplevel.get_widget('menuitem_stats_log')
-        # Get some toolbuttons
-        #self.menutoolbutton_diff = self.toplevel.get_widget('menutoolbutton_diff')
-        self.toolbutton_diff = self.toplevel.get_widget('toolbutton_diff')
-        self.toolbutton_log = self.toplevel.get_widget('toolbutton_log')
-        self.toolbutton_commit = self.toplevel.get_widget('toolbutton_commit')
-        self.toolbutton_pull = self.toplevel.get_widget('toolbutton_pull')
-        self.toolbutton_push = self.toplevel.get_widget('toolbutton_push')
-        # Get the drive selector
-        self.combobox_drive = gtk.combo_box_new_text()
-        self.combobox_drive.connect("changed", self._refresh_drives)
-        
-        self.vbox_main_right = self.toplevel.get_widget('vbox_main_right')
-    
-    def set_path(self, path):
-        """ Set the current path while browsing the directories. """
-        self._path = path
-    
-    def get_path(self):
-        """ Get the current path. """
-        return self._path
-    
+        self.menuitem_branch_get.set_sensitive(not self.notbranch)
+        self.menuitem_branch_checkout.set_sensitive(not self.notbranch)
+        self.menuitem_branch_pull.set_sensitive(not self.notbranch)
+        self.menuitem_branch_push.set_sensitive(not self.notbranch)
+        self.menuitem_branch_commit.set_sensitive(not self.notbranch)
+        self.menuitem_branch_status.set_sensitive(not self.notbranch)
+        self.menuitem_branch_missing.set_sensitive(not self.notbranch)
+        self.menuitem_stats.set_sensitive(not self.notbranch)
+        self.menuitem_add_files.set_sensitive(not self.notbranch)
+        self.menuitem_remove_files.set_sensitive(not self.notbranch)
+        self.menuitem_file_make_directory.set_sensitive(not self.notbranch)
+        self.menuitem_file_rename.set_sensitive(not self.notbranch)
+        self.menuitem_file_move.set_sensitive(not self.notbranch)
+        #self.menutoolbutton_diff.set_sensitive(True)
+        self.toolbutton_diff.set_sensitive(not self.notbranch)
+        self.toolbutton_log.set_sensitive(not self.notbranch)
+        self.toolbutton_commit.set_sensitive(not self.notbranch)
+        self.toolbutton_pull.set_sensitive(not self.notbranch)
+        self.toolbutton_push.set_sensitive(not self.notbranch)
+        
     def get_selected_right(self):
         """ Get the selected filename. """
         treeselection = self.treeview_right.get_selection()
@@ -413,8 +614,6 @@
     
     def refresh_left(self):
         """ Refresh the bookmark list. """
-        # set cursor to busy
-        self.set_busy(self.treeview_left)
         
         # Get TreeStore and clear it
         treestore = self.treeview_left.get_model()
@@ -435,20 +634,15 @@
         # Expand the tree
         self.treeview_left.expand_all()
 
-        self.set_busy(self.treeview_left, False)
-
     def refresh_right(self, path=None):
         """ Refresh the file list. """
         from bzrlib.workingtree import WorkingTree
 
-        self.set_busy(self.treeview_right)
-
         if path is None:
             path = self.get_path()
 
         # A workaround for double-clicking Bookmarks
         if not os.path.exists(path):
-            self.set_busy(self.treeview_right, False)
             return
 
         # Get ListStore and clear it
@@ -533,62 +727,6 @@
         # Add the ListStore to the TreeView
         self.treeview_right.set_model(liststore)
 
-        # Check if current directory is a branch
-        if not notbranch:
-            # Activate some items
-            self.menuitem_branch_init.set_sensitive(False)
-            self.menuitem_branch_get.set_sensitive(True)
-            self.menuitem_branch_checkout.set_sensitive(True)
-            self.menuitem_branch_pull.set_sensitive(True)
-            self.menuitem_branch_push.set_sensitive(True)
-            self.menuitem_branch_commit.set_sensitive(True)
-            self.menuitem_branch_status.set_sensitive(True)
-            self.menuitem_branch_missing.set_sensitive(True)
-            self.menuitem_stats.set_sensitive(True)
-            self.menuitem_add_files.set_sensitive(True)
-            self.menuitem_remove_files.set_sensitive(True)
-            self.menuitem_file_make_directory.set_sensitive(True)
-            self.menuitem_file_rename.set_sensitive(True)
-            self.menuitem_file_move.set_sensitive(True)
-            #self.menutoolbutton_diff.set_sensitive(True)
-            self.toolbutton_diff.set_sensitive(True)
-            self.toolbutton_log.set_sensitive(True)
-            self.toolbutton_commit.set_sensitive(True)
-            self.toolbutton_pull.set_sensitive(True)
-            self.toolbutton_push.set_sensitive(True)
-        else:
-            # Deactivate some items
-            self.menuitem_branch_init.set_sensitive(True)
-            self.menuitem_branch_get.set_sensitive(False)
-            self.menuitem_branch_checkout.set_sensitive(False)
-            self.menuitem_branch_pull.set_sensitive(False)
-            self.menuitem_branch_push.set_sensitive(False)
-            self.menuitem_branch_commit.set_sensitive(False)
-            self.menuitem_branch_status.set_sensitive(False)
-            self.menuitem_branch_missing.set_sensitive(False)
-            self.menuitem_stats.set_sensitive(False)
-            self.menuitem_add_files.set_sensitive(False)
-            self.menuitem_remove_files.set_sensitive(False)
-            self.menuitem_file_make_directory.set_sensitive(False)
-            self.menuitem_file_rename.set_sensitive(False)
-            self.menuitem_file_move.set_sensitive(False)
-            #self.menutoolbutton_diff.set_sensitive(False)
-            self.toolbutton_diff.set_sensitive(False)
-            self.toolbutton_log.set_sensitive(False)
-            self.toolbutton_commit.set_sensitive(False)
-            self.toolbutton_pull.set_sensitive(False)
-            self.toolbutton_push.set_sensitive(False)
-
-        self.set_busy(self.treeview_right, False)
-
-    def set_busy(self, widget, busy=True):
-        if busy:
-            widget.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))
-        else:
-            widget.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.LEFT_PTR))
-
-        gtk.main_iteration(0)
-
     def _harddisks(self):
         """ Returns hard drive letters under Win32. """
         try:
@@ -620,6 +758,8 @@
             drive = model[active][0]
             self.refresh_right(drive + '\\')
 
+import ConfigParser
+
 class OlivePreferences:
     """ A class which handles Olive's preferences. """
     def __init__(self):
@@ -642,6 +782,8 @@
             self.config.read([os.path.expanduser('~/olive.conf')])
         else:
             self.config.read([os.path.expanduser('~/.olive.conf')])
+ 
+
         
     def _get_default(self, option):
         """ Get the default option for a preference. """
@@ -675,34 +817,6 @@
             self.config.write(fp)
             fp.close()
 
-    def get_preference(self, option, kind='str'):
-        """ Get the value of the given option.
-        
-        :param kind: str/bool/int/float. default: str
-        """
-        if self.config.has_option('preferences', option):
-            if kind == 'bool':
-                return self.config.getboolean('preferences', option)
-            elif kind == 'int':
-                return self.config.getint('preferences', option)
-            elif kind == 'float':
-                return self.config.getfloat('preferences', option)
-            else:
-                return self.config.get('preferences', option)
-        else:
-            try:
-                return self._get_default(option)
-            except KeyError:
-                return None
-    
-    def set_preference(self, option, value):
-        """ Set the value of the given option. """
-        if self.config.has_section('preferences'):
-            self.config.set('preferences', option, value)
-        else:
-            self.config.add_section('preferences')
-            self.config.set('preferences', option, value)
-    
     def get_bookmarks(self):
         """ Return the list of bookmarks. """
         bookmarks = self.config.sections()
@@ -735,3 +849,32 @@
     def remove_bookmark(self, path):
         """ Remove bookmark. """
         return self.config.remove_section(path)
+
+    def set_preference(self, option, value):
+        """ Set the value of the given option. """
+        if self.config.has_section('preferences'):
+            self.config.set('preferences', option, value)
+        else:
+            self.config.add_section('preferences')
+            self.config.set('preferences', option, value)
+
+    def get_preference(self, option, kind='str'):
+        """ Get the value of the given option.
+        
+        :param kind: str/bool/int/float. default: str
+        """
+        if self.config.has_option('preferences', option):
+            if kind == 'bool':
+                return self.config.getboolean('preferences', option)
+            elif kind == 'int':
+                return self.config.getint('preferences', option)
+            elif kind == 'float':
+                return self.config.getfloat('preferences', option)
+            else:
+                return self.config.get('preferences', option)
+        else:
+            try:
+                return self._get_default(option)
+            except KeyError:
+                return None
+ 

=== modified file 'olive/add.py'
--- olive/add.py	2006-09-25 01:58:44 +0000
+++ olive/add.py	2006-09-27 21:05:19 +0000
@@ -21,26 +21,20 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
 
 import bzrlib.add
 import bzrlib.errors as errors
 
+from olive import gladefile
+
 class OliveAdd:
     """ Display the Add file(s) dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, wt, wtpath, selected=[]):
         """ Initialize the Add file(s) dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_add', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_add', 'olive-gtk')
         
         self.window = self.glade.get_widget('window_add')
         
@@ -51,6 +45,10 @@
         # Connect the signals to the handlers
         self.glade.signal_autoconnect(dic)
 
+        self.wt = wt
+        self.wtpath = wtpath
+        self.selected = selected
+
     def display(self):
         """ Display the Add file(s) dialog. """
         self.window.show_all()
@@ -59,45 +57,31 @@
         radio_selected = self.glade.get_widget('radiobutton_add_selected')
         radio_unknown = self.glade.get_widget('radiobutton_add_unknown')
         
-        directory = self.comm.get_path()
-        
-        self.comm.set_busy(self.window)
         if radio_selected.get_active():
             # Add only the selected file
-            filename = self.comm.get_selected_right()
+            filename = self.selected
             
             if filename is None:
-                self.dialog.error_dialog(_('No file was selected'),
+                error_dialog(_('No file was selected'),
                                          _('Please select a file from the list,\nor choose the other option.'))
-                self.comm.set_busy(self.window, False)
                 return
             
             try:
                 bzrlib.add.smart_add([directory + '/' + filename])
             except errors.NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
+                error_dialog(_('Directory is not a branch'),
                                          _('You can perform this action only in a branch.'))
-                self.comm.set_busy(self.window, False)
                 return
-            except:
-                raise
         elif radio_unknown.get_active():
             # Add unknown files recursively
             try:
                 bzrlib.add.smart_add([directory], True)
             except errors.NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
+                error_dialog(_('Directory is not a branch'),
                                          _('You can perform this action only in a branch.'))
-                self.comm.set_busy(self.window, False)
                 return
-            except:
-                raise
-        else:
-            # This should really never happen.
-            pass
         
         self.close()
-        self.comm.refresh_right()
     
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'olive/bookmark.py'
--- olive/bookmark.py	2006-09-05 01:55:34 +0000
+++ olive/bookmark.py	2006-09-27 21:05:19 +0000
@@ -21,23 +21,16 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
+from olive import gladefile
 
 class OliveBookmark:
     """ Display the Edit bookmark dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, comm):
         """ Initialize the Edit bookmark dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_bookmark', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_bookmark', 'olive-gtk')
         
         self.window = self.glade.get_widget('window_bookmark')
         
@@ -61,7 +54,7 @@
         
     def bookmark(self, widget):
         if self.entry_title.get_text() == '':
-            self.dialog.error_dialog(_('No title given'),
+            error_dialog(_('No title given'),
                                      _('Please specify a title to continue.'))
             return
         
@@ -69,7 +62,6 @@
                                           self.entry_title.get_text())
         
         self.close()
-        self.comm.refresh_left()
     
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'olive/branch.py'
--- olive/branch.py	2006-09-05 01:55:34 +0000
+++ olive/branch.py	2006-09-27 20:30:59 +0000
@@ -21,26 +21,19 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
 
 import bzrlib.errors as errors
+from __init__ import gladefile
 
 class OliveBranch:
     """ Display branch dialog and perform the needed operations. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, path=None):
         """ Initialize the Branch dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_branch', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
-        
+        self.glade = gtk.glade.XML(gladefile, 'window_branch', 'olive-gtk')
+
         self.window = self.glade.get_widget('window_branch')
         
         # Dictionary for signal_autoconnect
@@ -52,7 +45,8 @@
         
         # Save FileChooser state
         self.filechooser = self.glade.get_widget('filechooserbutton_branch')
-        self.filechooser.set_filename(self.comm.get_path())
+        if path is not None:
+            self.filechooser.set_filename(path)
 
     def display(self):
         """ Display the Branch dialog. """
@@ -62,7 +56,7 @@
         entry_location = self.glade.get_widget('entry_branch_location')
         location = entry_location.get_text()
         if location is '':
-            self.dialog.error_dialog(_('Missing branch location'),
+            error_dialog(_('Missing branch location'),
                                      _('You must specify a branch location.'))
             return
         
@@ -72,18 +66,15 @@
         revno = spinbutton_revno.get_value_as_int()
         revision_id = br_from.get_rev_id(revno)
         
-        self.comm.set_busy(self.window)
         try:
             from bzrlib.transport import get_transport
 
             br_from = Branch.open(location)
-
             br_from.lock_read()
 
             try:
                 destination = destination + '/' + os.path.basename(location.rstrip("/\\"))
                 to_transport = get_transport(destination)
-
                 to_transport.mkdir('.')
 
                 try:
@@ -97,33 +88,27 @@
                 br_from.unlock()
                 
             self.close()
-            self.dialog.info_dialog(_('Branching successful'),
-                                _('%d revision(s) branched.') % revs)
-            self.comm.refresh_right()
+            info_dialog(_('Branching successful'),
+                        _('%d revision(s) branched.') % revs)
         except errors.NonExistingSource, errmsg:
-            self.dialog.error_dialog(_('Non existing source'),
+            error_dialog(_('Non existing source'),
                                      _("The location (%s)\ndoesn't exist.") % errmsg)
-            self.comm.set_busy(self.window, False)
             return
         except errors.TargetAlreadyExists, errmsg:
-            self.dialog.error_dialog(_('Target already exists'),
+            error_dialog(_('Target already exists'),
                                      _('Target directory (%s)\nalready exists. Please select another target.') % errmsg)
-            self.comm.set_busy(self.window, False)
             return
         except errors.NonExistingParent, errmsg:
-            self.dialog.error_dialog(_('Non existing parent directory'),
+            error_dialog(_('Non existing parent directory'),
                                      _("The parent directory (%s)\ndoesn't exist.") % errmsg)
-            self.comm.set_busy(self.window, False)
             return
         except errors.NonExistingRevision:
-            self.dialog.error_dialog(_('Non existing revision'),
+            error_dialog(_('Non existing revision'),
                                      _("The revision you specified doesn't exist."))
-            self.comm.set_busy(self.window, False)
             return
         except errors.NotBranchError, errmsg:
-            self.dialog.error_dialog(_('Location is not a branch'),
+            error_dialog(_('Location is not a branch'),
                                      _('The specified location has to be a branch.'))
-            self.comm.set_busy(self.window, False)
             return
         
 

=== modified file 'olive/checkout.py'
--- olive/checkout.py	2006-09-05 01:55:34 +0000
+++ olive/checkout.py	2006-09-28 06:35:56 +0000
@@ -21,25 +21,19 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
 
 import bzrlib.errors as errors
 
+from olive import gladefile
+
 class OliveCheckout:
     """ Display checkout dialog and perform the needed operations. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, path=None):
         """ Initialize the Checkout dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_checkout', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_checkout', 'olive-gtk')
         
         self.window = self.glade.get_widget('window_checkout')
         
@@ -52,7 +46,8 @@
         
         # Save FileChooser state
         self.filechooser = self.glade.get_widget('filechooserbutton_checkout')
-        self.filechooser.set_filename(self.comm.get_path())
+        if path is not None:
+            self.filechooser.set_filename(path)
 
     def display(self):
         """ Display the Checkout dialog. """
@@ -62,7 +57,7 @@
         entry_location = self.glade.get_widget('entry_checkout_location')
         location = entry_location.get_text()
         if location is '':
-            self.dialog.error_dialog(_('Missing branch location'),
+            error_dialog(_('Missing branch location'),
                                      _('You must specify a branch location.'))
             return
         
@@ -75,7 +70,6 @@
         checkbutton_lightweight = self.glade.get_widget('checkbutton_checkout_lightweight')
         lightweight = checkbutton_lightweight.get_active()
         
-        self.comm.set_busy(self.window)
         try:
             source = Branch.open(location)
             
@@ -114,22 +108,17 @@
             finally:
                 bzrlib.bzrdir.BzrDirFormat.set_default_format(old_format)
         except errors.NotBranchError, errmsg:
-            self.dialog.error_dialog(_('Location is not a branch'),
+            error_dialog(_('Location is not a branch'),
                                      _('The specified location has to be a branch.'))
-            self.comm.set_busy(self.window, False)
             return
         except errors.TargetAlreadyExists, errmsg:
-            self.dialog.error_dialog(_('Target already exists'),
+            error_dialog(_('Target already exists'),
                                      _('Target directory (%s)\nalready exists. Please select another target.') % errmsg)
-            self.comm.set_busy(self.window, False)
             return
         except errors.NonExistingParent, errmsg:
-            self.dialog.error_dialog(_('Non existing parent directory'),
+            error_dialog(_('Non existing parent directory'),
                                      _("The parent directory (%s)\ndoesn't exist.") % errmsg)
-            self.comm.set_busy(self.window, False)
             return
-        except:
-            raise
         
         self.close()
         self.comm.refresh_right()

=== modified file 'olive/commit.py'
--- olive/commit.py	2006-09-06 00:22:31 +0000
+++ olive/commit.py	2006-09-27 21:05:19 +0000
@@ -21,48 +21,35 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-    import gobject
-    import pango
-except:
-    sys.exit(1)
+import gtk
+import gtk.glade
+import gobject
+import pango
 
 from bzrlib import version_info
 
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
+from dialog import error_dialog
+from olive import gladefile
+
 class OliveCommit:
     """ Display Commit dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, wt, wtpath):
         """ Initialize the Commit dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_commit', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
-        
+        self.glade = gtk.glade.XML(gladefile, 'window_commit', 'olive-gtk')
+        
+        self.wt = wt
+        self.wtpath = wtpath
+
         # Get some important widgets
         self.window = self.glade.get_widget('window_commit')
         self.checkbutton_local = self.glade.get_widget('checkbutton_commit_local')
         self.textview = self.glade.get_widget('textview_commit')
         self.file_view = self.glade.get_widget('treeview_commit_select')
 
-        # Check if current location is a branch
-        try:
-            (self.wt, path) = WorkingTree.open_containing(self.comm.get_path())
-            branch = self.wt.branch
-        except errors.NotBranchError:
-            self.notbranch = True
-            return
-        except:
-            raise
-
-        file_id = self.wt.path2id(path)
+        file_id = self.wt.path2id(wtpath)
 
         self.notbranch = False
         if file_id is None:
@@ -71,10 +58,7 @@
         
         # Set the delta
         self.old_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
-        if version_info < (0, 9):
-            self.delta = compare_trees(self.old_tree, self.wt)
-        else:
-            self.delta = self.wt.changes_from(self.old_tree)
+        self.delta = self.wt.changes_from(self.old_tree)
         
         # Dictionary for signal_autoconnect
         dic = { "on_button_commit_commit_clicked": self.commit,
@@ -89,14 +73,11 @@
     def display(self):
         """ Display the Push dialog. """
         if self.notbranch:
-            self.dialog.error_dialog(_('Directory is not a branch'),
+            error_dialog(_('Directory is not a branch'),
                                      _('You can perform this action only in a branch.'))
             self.close()
         else:
-            from bzrlib.branch import Branch
-            branch = Branch.open_containing(self.comm.get_path())[0]
-
-            if branch.get_bound_location() is not None:
+            if self.wt.branch.get_bound_location() is not None:
                 # we have a checkout, so the local commit checkbox must appear
                 self.checkbutton_local.show()
             
@@ -104,7 +85,6 @@
             self.window.show()
             
     
-    # This code is from Jelmer Vernooij's bzr-gtk branch
     def _create_file_view(self):
         self.file_store = gtk.ListStore(gobject.TYPE_BOOLEAN,
                                         gobject.TYPE_STRING,
@@ -141,7 +121,6 @@
             it = self.file_store.iter_next(it)
 
         return ret
-    # end of bzr-gtk code
     
     def _toggle_commit(self, cell, path, model):
         model[path][0] = not model[path][0]
@@ -157,8 +136,6 @@
         
         specific_files = self._get_specific_files()
         
-        self.comm.set_busy(self.window)
-        # merged from Jelmer Vernooij's olive integration branch
         try:
             self.wt.commit(message, 
                            allow_pointless=checkbutton_force.get_active(),
@@ -166,40 +143,37 @@
                            local=self.checkbutton_local.get_active(),
                            specific_files=specific_files)
         except errors.NotBranchError:
-            self.dialog.error_dialog(_('Directory is not a branch'),
+            error_dialog(_('Directory is not a branch'),
                                      _('You can perform this action only in a branch.'))
-            self.comm.set_busy(self.window, False)
             return
         except errors.LocalRequiresBoundBranch:
-            self.dialog.error_dialog(_('Directory is not a checkout'),
+            error_dialog(_('Directory is not a checkout'),
                                      _('You can perform local commit only on checkouts.'))
-            self.comm.set_busy(self.window, False)
             return
         except errors.PointlessCommit:
-            self.dialog.error_dialog(_('No changes to commit'),
+            error_dialog(_('No changes to commit'),
                                      _('Try force commit if you want to commit anyway.'))
-            self.comm.set_busy(self.window, False)
             return
         except errors.ConflictsInTree:
-            self.dialog.error_dialog(_('Conflicts in tree'),
+            error_dialog(_('Conflicts in tree'),
                                      _('You need to resolve the conflicts before committing.'))
-            self.comm.set_busy(self.window, False)
             return
         except errors.StrictCommitFailed:
-            self.dialog.error_dialog(_('Strict commit failed'),
+            error_dialog(_('Strict commit failed'),
                                      _('There are unknown files in the working tree.\nPlease add or delete them.'))
-            self.comm.set_busy(self.window, False)
             return
         except errors.BoundBranchOutOfDate, errmsg:
-            self.dialog.error_dialog(_('Bound branch is out of date'),
+            error_dialog(_('Bound branch is out of date'),
                                      _('%s') % errmsg)
-            self.comm.set_busy(self.window, False)
-            return
-        except:
-            raise
+            return
+        except errors.BzrError, msg:
+            error_dialog(_('Unknown bzr error'), str(msg))
+            return
+        except Exception, msg:
+            error_dialog(_('Unknown error'), str(msg))
+            return
         
         self.close()
-        self.comm.refresh_right()
         
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'olive/dialog.py'
--- olive/dialog.py	2006-09-13 20:19:31 +0000
+++ olive/dialog.py	2006-09-27 20:30:59 +0000
@@ -21,69 +21,62 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
-
-class OliveDialog:
-    def __init__(self, gladefile):
-        self.gladefile = gladefile
-        
-    def about(self):
-        """ Display the AboutDialog. """
-        import olive
-
-        # Load AboutDialog description
-        dglade = gtk.glade.XML(self.gladefile, 'aboutdialog')
-        dialog = dglade.get_widget('aboutdialog')
-
-        # Set version
-        dialog.set_version(olive.__version__)
-        
-        # Destroy the dialog
-        if dialog.run() == gtk.RESPONSE_CANCEL:
-            dialog.destroy()
-    
-    def _message_dialog(self, type, primary, secondary):
-        """ Display a given type of MessageDialog with the given message.
-        
-        :param type: error | warning | info
-        
-        :param message: the message you want to display.
-        """
-        if type == 'error':
-            dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
-                                       type=gtk.MESSAGE_ERROR,
-                                       buttons=gtk.BUTTONS_OK)
-            dialog.set_markup('<big><b>' + primary + '</b></big>')
-        elif type == 'warning':
-            dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
-                                       type=gtk.MESSAGE_WARNING,
-                                       buttons=gtk.BUTTONS_OK)
-            dialog.set_markup('<big><b>' + primary + '</b></big>')
-        elif type == 'info':
-            dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
-                                       type=gtk.MESSAGE_INFO,
-                                       buttons=gtk.BUTTONS_OK)
-            dialog.set_markup('<big><b>' + primary + '</b></big>')
-        else:
-            return
-        
-        dialog.format_secondary_markup(secondary)
-        
-        if dialog.run() == gtk.RESPONSE_OK:
-            dialog.destroy()
-    
-    def error_dialog(self, primary, secondary):
-        """ Display an error dialog with the given message. """
-        self._message_dialog('error', primary, secondary)
-    
-    def info_dialog(self, primary, secondary):
-        """ Display an info dialog with the given message. """
-        self._message_dialog('info', primary, secondary)
-    
-    def warning_dialog(self, primary, secondary):
-        """ Display a warning dialog with the given message. """
-        self._message_dialog('warning', primary, secondary)
+import gtk
+import gtk.glade
+
+def about():
+	""" Display the AboutDialog. """
+	import olive
+
+	# Load AboutDialog description
+	dglade = gtk.glade.XML(gladefile, 'aboutdialog')
+	dialog = dglade.get_widget('aboutdialog')
+
+	# Set version
+	dialog.set_version(olive.__version__)
+	
+	# Destroy the dialog
+	if dialog.run() == gtk.RESPONSE_CANCEL:
+		dialog.destroy()
+
+def _message_dialog(type, primary, secondary):
+	""" Display a given type of MessageDialog with the given message.
+	
+	:param type: error | warning | info
+	
+	:param message: the message you want to display.
+	"""
+	if type == 'error':
+		dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
+								   type=gtk.MESSAGE_ERROR,
+								   buttons=gtk.BUTTONS_OK)
+		dialog.set_markup('<big><b>' + primary + '</b></big>')
+	elif type == 'warning':
+		dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
+								   type=gtk.MESSAGE_WARNING,
+								   buttons=gtk.BUTTONS_OK)
+		dialog.set_markup('<big><b>' + primary + '</b></big>')
+	elif type == 'info':
+		dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL,
+								   type=gtk.MESSAGE_INFO,
+								   buttons=gtk.BUTTONS_OK)
+		dialog.set_markup('<big><b>' + primary + '</b></big>')
+	else:
+		return
+	
+	dialog.format_secondary_markup(secondary)
+	
+	if dialog.run() == gtk.RESPONSE_OK:
+		dialog.destroy()
+
+def error_dialog(primary, secondary):
+	""" Display an error dialog with the given message. """
+	_message_dialog('error', primary, secondary)
+
+def info_dialog(primary, secondary):
+	""" Display an info dialog with the given message. """
+	_message_dialog('info', primary, secondary)
+
+def warning_dialog(primary, secondary):
+	""" Display a warning dialog with the given message. """
+	_message_dialog('warning', primary, secondary)

=== removed file 'olive/diff.py'
--- olive/diff.py	2006-09-05 01:55:34 +0000
+++ olive/diff.py	1970-01-01 00:00:00 +0000
@@ -1,188 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# Some parts of the code:
-# Copyright (C) 2005 by Canonical Ltd.
-# Author: Scott James Remnant <scott@ubuntu.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import sys
-
-from cStringIO import StringIO
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-try:
-    import gtk
-    import gtk.glade
-    import gobject
-    import pango
-except:
-    sys.exit(1)
-
-try:
-    import gtksourceview
-    have_gtksourceview = True
-except ImportError:
-    have_gtksourceview = False
-
-import bzrlib
-
-if bzrlib.version_info < (0, 9):
-    # function deprecated after 0.9
-    from bzrlib.delta import compare_trees
-
-from bzrlib.diff import show_diff_trees
-import bzrlib.errors as errors
-from bzrlib.workingtree import WorkingTree
-
-class OliveDiff:
-    """ Display Diff window and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
-        """ Initialize the Diff window. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_diff', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
-        
-        # Get some important widgets
-        self.window = self.glade.get_widget('window_diff')
-        self.treeview = self.glade.get_widget('treeview_diff_files')
-
-        # Check if current location is a branch
-        try:
-            (self.wt, path) = WorkingTree.open_containing(self.comm.get_path())
-            branch = self.wt.branch
-        except errors.NotBranchError:
-            self.notbranch = True
-            return
-        except:
-            raise
-
-        file_id = self.wt.path2id(path)
-
-        self.notbranch = False
-        if file_id is None:
-            self.notbranch = True
-            return
-        
-        # Set the old working tree
-        self.old_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_diff_close_clicked": self.close,
-                "on_treeview_diff_files_cursor_changed": self.cursor_changed }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        # Create the file list
-        self._create_file_view()
-        
-        # Generate initial diff
-        self._init_diff()
-    
-    def display(self):
-        """ Display the Diff window. """
-        if self.notbranch:
-            self.dialog.error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
-            self.close()
-        else:
-            self.window.show_all()
-    
-    def _create_file_view(self):
-        """ Create the list of files. """
-        self.model = gtk.TreeStore(str, str)
-        self.treeview.set_model(self.model)
-        
-        cell = gtk.CellRendererText()
-        cell.set_property("width-chars", 20)
-        column = gtk.TreeViewColumn()
-        column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 0)
-        self.treeview.append_column(column)
-        
-        if have_gtksourceview:
-            self.buffer = gtksourceview.SourceBuffer()
-            slm = gtksourceview.SourceLanguagesManager()
-            gsl = slm.get_language_from_mime_type("text/x-patch")
-            self.buffer.set_language(gsl)
-            self.buffer.set_highlight(True)
-
-            sourceview = gtksourceview.SourceView(self.buffer)
-        else:
-            self.buffer = gtk.TextBuffer()
-            sourceview = gtk.TextView(self.buffer)
-
-        sourceview.set_editable(False)
-        sourceview.modify_font(pango.FontDescription("Monospace"))
-        scrollwin_diff = self.glade.get_widget('scrolledwindow_diff_diff')
-        scrollwin_diff.add(sourceview)
-    
-    def _init_diff(self):
-        """ Generate initial diff. """
-        self.model.clear()
-        if bzrlib.version_info < (0, 9):
-            delta = compare_trees(self.old_tree, self.wt)
-        else:
-            delta = self.wt.changes_from(self.old_tree)
-
-        self.model.append(None, [ _('Complete Diff'), "" ])
-
-        if len(delta.added):
-            titer = self.model.append(None, [ _('Added'), None ])
-            for path, id, kind in delta.added:
-                self.model.append(titer, [ path, path ])
-
-        if len(delta.removed):
-            titer = self.model.append(None, [ _('Removed'), None ])
-            for path, id, kind in delta.removed:
-                self.model.append(titer, [ path, path ])
-
-        if len(delta.renamed):
-            titer = self.model.append(None, [ _('Renamed'), None ])
-            for oldpath, newpath, id, kind, text_modified, meta_modified \
-                    in delta.renamed:
-                self.model.append(titer, [ oldpath, newpath ])
-
-        if len(delta.modified):
-            titer = self.model.append(None, [ _('Modified'), None ])
-            for path, id, kind, text_modified, meta_modified in delta.modified:
-                self.model.append(titer, [ path, path ])
-
-        self.treeview.expand_all()
-    
-    def cursor_changed(self, *args):
-        """ Callback when the TreeView cursor changes. """
-        (path, col) = self.treeview.get_cursor()
-        specific_files = [ self.model[path][1] ]
-        if specific_files == [ None ]:
-            return
-        elif specific_files == [ "" ]:
-            specific_files = []
-
-        s = StringIO()
-        show_diff_trees(self.old_tree, self.wt, s, specific_files)
-        self.buffer.set_text(s.getvalue())
-    
-    def close(self, widget=None):
-        self.window.destroy()

=== removed file 'olive/handler.py'
--- olive/handler.py	2006-09-27 19:10:00 +0000
+++ olive/handler.py	1970-01-01 00:00:00 +0000
@@ -1,349 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-import sys
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
-
-import bzrlib.errors as errors
-from bzrlib.branch import Branch
-
-from dialog import OliveDialog
-from menu import OliveMenu
-from launch import launch
-
-class OliveHandler:
-    """ Signal handler class for Olive. """
-    def __init__(self, gladefile, comm):
-        self.gladefile = gladefile
-        self.comm = comm
-        
-        self.dialog = OliveDialog(self.gladefile)
-        
-        self.menu = OliveMenu(self.gladefile, self.comm, self.dialog)
-    
-    def on_about_activate(self, widget):
-        self.dialog.about()
-        
-    def on_menuitem_add_files_activate(self, widget):
-        """ Add file(s)... menu handler. """
-        from add import OliveAdd
-        add = OliveAdd(self.gladefile, self.comm, self.dialog)
-        add.display()
-    
-    def on_menuitem_branch_get_activate(self, widget):
-        """ Branch/Get... menu handler. """
-        from branch import OliveBranch
-        branch = OliveBranch(self.gladefile, self.comm, self.dialog)
-        branch.display()
-    
-    def on_menuitem_branch_checkout_activate(self, widget):
-        """ Branch/Checkout... menu handler. """
-        from checkout import OliveCheckout
-        checkout = OliveCheckout(self.gladefile, self.comm, self.dialog)
-        checkout.display()
-    
-    def on_menuitem_branch_commit_activate(self, widget):
-        """ Branch/Commit... menu handler. """
-        from commit import OliveCommit
-        commit = OliveCommit(self.gladefile, self.comm, self.dialog)
-        commit.display()
-    
-    def on_menuitem_branch_missing_revisions_activate(self, widget):
-        """ Branch/Missing revisions menu handler. """
-        
-        self.comm.set_busy(self.comm.window_main)
-        
-        try:
-            import bzrlib
-            
-            try:
-                local_branch = Branch.open_containing(self.comm.get_path())[0]
-            except NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
-                                         _('You can perform this action only in a branch.'))
-                return
-            
-            other_branch = local_branch.get_parent()
-            if other_branch is None:
-                self.dialog.error_dialog(_('Parent location is unknown'),
-                                         _('Cannot determine missing revisions if no parent location is known.'))
-                return
-            
-            remote_branch = Branch.open(other_branch)
-            
-            if remote_branch.base == local_branch.base:
-                remote_branch = local_branch
-
-            ret = len(local_branch.missing_revisions(remote_branch))
-
-            if ret > 0:
-                self.dialog.info_dialog(_('There are missing revisions'),
-                                        _('%d revision(s) missing.') % ret)
-            else:
-                self.dialog.info_dialog(_('Local branch up to date'),
-                                        _('There are no missing revisions.'))
-        finally:
-            self.comm.set_busy(self.comm.window_main, False)
-    
-    def on_menuitem_branch_pull_activate(self, widget):
-        """ Branch/Pull menu handler. """
-        
-        self.comm.set_busy(self.comm.window_main)
-
-        try:
-            try:
-                from bzrlib.workingtree import WorkingTree
-                tree_to = WorkingTree.open_containing(self.comm.get_path())[0]
-                branch_to = tree_to.branch
-            except errors.NoWorkingTree:
-                tree_to = None
-                branch_to = Branch.open_containing(self.comm.get_path())[0]
-            except errors.NotBranchError:
-                 self.dialog.error_dialog(_('Directory is not a branch'),
-                                         _('You can perform this action only in a branch.'))
-
-            location = branch_to.get_parent()
-            if location is None:
-                self.dialog.error_dialog(_('Parent location is unknown'),
-                                         _('Pulling is not possible until there is a parent location.'))
-                return
-
-            try:
-                branch_from = Branch.open(location)
-            except errors.NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
-                                         _('You can perform this action only in a branch.'))
-
-            if branch_to.get_parent() is None:
-                branch_to.set_parent(branch_from.base)
-
-            old_rh = branch_to.revision_history()
-            if tree_to is not None:
-                tree_to.pull(branch_from)
-            else:
-                branch_to.pull(branch_from)
-            
-            self.dialog.info_dialog(_('Pull successful'),
-                                    _('%d revision(s) pulled.') % ret)
-            
-        finally:
-            self.comm.set_busy(self.comm.window_main, False)
-    
-    def on_menuitem_branch_push_activate(self, widget):
-        """ Branch/Push... menu handler. """
-        from push import OlivePush
-        push = OlivePush(self.gladefile, self.comm, self.dialog)
-        push.display()
-    
-    def on_menuitem_branch_status_activate(self, widget):
-        """ Branch/Status... menu handler. """
-        from status import OliveStatus
-        status = OliveStatus(self.gladefile, self.comm, self.dialog)
-        status.display()
-    
-    def on_menuitem_branch_initialize_activate(self, widget):
-        """ Initialize current directory. """
-        try:
-            location = self.comm.get_path()
-            from bzrlib.builtins import get_format_type
-
-            format = get_format_type('default')
- 
-            if not os.path.exists(location):
-                os.mkdir(location)
-     
-            try:
-                existing_bzrdir = bzrdir.BzrDir.open(location)
-            except NotBranchError:
-                bzrdir.BzrDir.create_branch_convenience(location, format=format)
-            else:
-                if existing_bzrdir.has_branch():
-                    if existing_bzrdir.has_workingtree():
-                        raise AlreadyBranchError(location)
-                    else:
-                        raise BranchExistsWithoutWorkingTree(location)
-                else:
-                    existing_bzrdir.create_branch()
-                    existing_bzrdir.create_workingtree()
-        except errors.AlreadyBranchError, errmsg:
-            self.dialog.error_dialog(_('Directory is already a branch'),
-                                     _('The current directory (%s) is already a branch.\nYou can start using it, or initialize another directory.') % errmsg)
-        except errors.BranchExistsWithoutWorkingTree, errmsg:
-            self.dialog.error_dialog(_('Branch without a working tree'),
-                                     _('The current directory (%s)\nis a branch without a working tree.') % errmsg)
-        else:
-            self.dialog.info_dialog(_('Initialize successful'),
-                                    _('Directory successfully initialized.'))
-            self.comm.refresh_right()
-        
-    def on_menuitem_file_make_directory_activate(self, widget):
-        """ File/Make directory... menu handler. """
-        from mkdir import OliveMkdir
-        mkdir = OliveMkdir(self.gladefile, self.comm, self.dialog)
-        mkdir.display()
-    
-    def on_menuitem_file_move_activate(self, widget):
-        """ File/Move... menu handler. """
-        from move import OliveMove
-        move = OliveMove(self.gladefile, self.comm, self.dialog)
-        move.display()
-    
-    def on_menuitem_file_rename_activate(self, widget):
-        """ File/Rename... menu handler. """
-        from rename import OliveRename
-        rename = OliveRename(self.gladefile, self.comm, self.dialog)
-        rename.display()
-
-    def on_menuitem_remove_file_activate(self, widget):
-        """ Remove (unversion) selected file. """
-        from remove import OliveRemove
-        remove = OliveRemove(self.gladefile, self.comm, self.dialog)
-        remove.display()
-    
-    def on_menuitem_stats_diff_activate(self, widget):
-        """ Statistics/Differences... menu handler. """
-        from diff import OliveDiff
-        diff = OliveDiff(self.gladefile, self.comm, self.dialog)
-        diff.display()
-    
-    def on_menuitem_stats_infos_activate(self, widget):
-        """ Statistics/Informations... menu handler. """
-        from info import OliveInfo
-        info = OliveInfo(self.gladefile, self.comm, self.dialog)
-        info.display()
-    
-    def on_menuitem_stats_log_activate(self, widget):
-        """ Statistics/Log... menu handler. """
-        from log import OliveLog
-        log = OliveLog(self.gladefile, self.comm, self.dialog)
-        log.display()
-    
-    def on_menuitem_view_refresh_activate(self, widget):
-        """ View/Refresh menu handler. """
-        # Refresh the left pane
-        self.comm.refresh_left()
-        # Refresh the right pane
-        self.comm.refresh_right()
-    
-    def on_menuitem_view_show_hidden_files_activate(self, widget):
-        """ View/Show hidden files menu handler. """
-        if widget.get_active():
-            # Show hidden files
-            self.comm.pref.set_preference('dotted_files', True)
-            self.comm.pref.refresh()
-            self.comm.refresh_right()
-        else:
-            # Do not show hidden files
-            self.comm.pref.set_preference('dotted_files', False)
-            self.comm.pref.refresh()
-            self.comm.refresh_right()
-
-    def on_treeview_left_button_press_event(self, widget, event):
-        """ Occurs when somebody right-clicks in the bookmark list. """
-        if event.button == 3:
-            # Don't show context with nothing selected
-            if self.comm.get_selected_left() == None:
-                return
-
-            self.menu.left_context_menu().popup(None, None, None, 0,
-                                                event.time)
-        
-    def on_treeview_left_row_activated(self, treeview, path, view_column):
-        """ Occurs when somebody double-clicks or enters an item in the
-        bookmark list. """
-
-        newdir = self.comm.get_selected_left()
-        if newdir == None:
-            return
-
-        self.comm.set_busy(treeview)
-        self.comm.set_path(newdir)
-        self.comm.refresh_right()
-        self.comm.set_busy(treeview, False)
-    
-    def on_treeview_right_button_press_event(self, widget, event):
-        """ Occurs when somebody right-clicks in the file list. """
-        if event.button == 3:
-            # get the menu items
-            m_add = self.menu.ui.get_widget('/context_right/add')
-            m_remove = self.menu.ui.get_widget('/context_right/remove')
-            m_commit = self.menu.ui.get_widget('/context_right/commit')
-            m_diff = self.menu.ui.get_widget('/context_right/diff')
-            # check if we're in a branch
-            try:
-                from bzrlib.branch import Branch
-                Branch.open_containing(self.comm.get_path())
-                m_add.set_sensitive(True)
-                m_remove.set_sensitive(True)
-                m_commit.set_sensitive(True)
-                m_diff.set_sensitive(True)
-            except errors.NotBranchError:
-                m_add.set_sensitive(False)
-                m_remove.set_sensitive(False)
-                m_commit.set_sensitive(False)
-                m_diff.set_sensitive(False)
-            self.menu.right_context_menu().popup(None, None, None, 0,
-                                                 event.time)
-        
-    def on_treeview_right_row_activated(self, treeview, path, view_column):
-        """ Occurs when somebody double-clicks or enters an item in the
-        file list. """
-        import os.path
-        
-        newdir = self.comm.get_selected_right()
-        
-        if newdir == '..':
-            self.comm.set_path(os.path.split(self.comm.get_path())[0])
-        else:
-            fullpath = self.comm.get_path() + os.sep + newdir
-            if os.path.isdir(fullpath):
-                # selected item is an existant directory
-                self.comm.set_path(fullpath)
-            else:
-                launch(fullpath) 
-        
-        self.comm.refresh_right()
-    
-    def on_window_main_delete_event(self, widget, event=None):
-        """ Do some stuff before exiting. """
-        width, height = self.comm.window_main.get_size()
-        self.comm.pref.set_preference('window_width', width)
-        self.comm.pref.set_preference('window_height', height)
-        x, y = self.comm.window_main.get_position()
-        self.comm.pref.set_preference('window_x', x)
-        self.comm.pref.set_preference('window_y', y)
-        self.comm.pref.set_preference('paned_position',
-                                      self.comm.hpaned_main.get_position())
-        
-        self.comm.pref.write()
-        self.comm.window_main.destroy()
-
-    def not_implemented(self, widget):
-        """ Display a Not implemented error message. """
-        self.dialog.error_dialog(_('We feel sorry'),
-                                 _('This feature is not yet implemented.'))
-

=== modified file 'olive/info.py'
--- olive/info.py	2006-09-13 20:19:31 +0000
+++ olive/info.py	2006-09-27 21:05:19 +0000
@@ -21,16 +21,16 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-    import gobject
-    import pango
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
+import gobject
+import pango
 
 import bzrlib.errors as errors
 
+from olive import gladefile
+
 def info(location):
     """ Get info about branch, working tree, and repository
     
@@ -144,15 +144,9 @@
 
 class OliveInfo:
     """ Display Informations window and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, wt):
         """ Initialize the Informations window. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_info', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_info', 'olive-gtk')
         
         # Get the Informations window widget
         self.window = self.glade.get_widget('window_info')
@@ -160,7 +154,7 @@
         # Check if current location is a branch
         self.notbranch = False
         try:
-            self.ret = info(self.comm.get_path())
+            self.ret = info(wt.basedir)
         except errors.NotBranchError:
             self.notbranch = True
             return
@@ -559,7 +553,7 @@
     def display(self):
         """ Display the Informations window. """
         if self.notbranch:
-            self.dialog.error_dialog(_('Directory is not a branch'),
+            error_dialog(_('Directory is not a branch'),
                                      _('You can perform this action only in a branch.'))
             self.close()
         else:

=== removed file 'olive/log.py'
--- olive/log.py	2006-09-27 13:01:39 +0000
+++ olive/log.py	1970-01-01 00:00:00 +0000
@@ -1,75 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import sys
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-try:
-    import gtk
-    import gtk.glade
-    import gobject
-    import pango
-except:
-    sys.exit(1)
-
-from bzrlib.branch import Branch
-import bzrlib.errors as errors
-
-nobzrgtk = False
-try:
-    from bzrlib.plugins.gtk.viz.branchwin import BranchWindow
-except ImportError:
-    nobzrgtk = True
-
-class OliveLog:
-    """ Display Log (bzrk) window and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
-        """ Initialize the Log (bzrk) window. """
-        self.gladefile = gladefile
-
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
-        
-        # Check if current location is a branch
-        self.notbranch = False
-        try:
-            (self.branch, path) = Branch.open_containing(self.comm.get_path())
-        except errors.NotBranchError:
-            self.notbranch = True
-            return
-        except:
-            raise
-        
-        self.revid = self.branch.last_revision()
-
-    def display(self):
-        """ Display the Log (bzrk) window. """
-        if self.notbranch:
-            self.dialog.error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
-        elif nobzrgtk:
-            self.dialog.error_dialog(_('bzr-gtk plugin not available'),
-                                     _('Please install the bzr-gtk plugin in order to have visual log support.'))
-        else:
-            window = BranchWindow()
-            window.set_branch(self.branch, self.revid, None)
-            window.show()

=== modified file 'olive/menu.py'
--- olive/menu.py	2006-09-13 20:19:31 +0000
+++ olive/menu.py	2006-09-27 20:30:59 +0000
@@ -22,19 +22,17 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
 
 import bzrlib.errors as errors
+from dialog import error_dialog
 
 from launch import launch
 
 class OliveMenu:
     """ This class is responsible for building the context menus. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self):
         # Load the UI file
         if sys.platform == 'win32':
             self.uifile = os.path.dirname(sys.executable) + "/share/olive/cmenu.ui"
@@ -50,10 +48,6 @@
                 print _('UI description file cannot be found.')
                 sys.exit(1)
         
-        self.gladefile = gladefile
-        self.comm = comm
-        self.dialog = dialog
-        
         # Create the file list context menu
         self.ui = gtk.UIManager()
         
@@ -138,15 +132,15 @@
         filename = self.comm.get_selected_right()
             
         if filename is None:
-            self.dialog.error_dialog(_('No file was selected'),
-                                     _('Please select a file from the list,\nor choose the other option.'))
+            error_dialog(_('No file was selected'),
+                         _('Please select a file from the list,\nor choose the other option.'))
             return
         
         try:
             bzrlib.add.smart_add([directory + '/' + filename])
         except errors.NotBranchError:
-            self.dialog.error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
+            error_dialog(_('Directory is not a branch'),
+                         _('You can perform this action only in a branch.'))
             return
         
         self.comm.refresh_right()
@@ -158,8 +152,8 @@
         filename = self.comm.get_selected_right()
         
         if filename is None:
-            self.dialog.error_dialog(_('No file was selected'),
-                                     _('Please select a file from the list,\nor choose the other option.'))
+            error_dialog(_('No file was selected'),
+                         _('Please select a file from the list,\nor choose the other option.'))
             return
         
         try:
@@ -167,15 +161,13 @@
             wt.remove(path)
 
         except errors.NotBranchError:
-            self.dialog.error_dialog(_('Directory is not a branch'),
+            error_dialog(_('Directory is not a branch'),
                                      _('You can perform this action only in a branch.'))
             return
         except errors.NotVersionedError:
-            self.dialog.error_dialog(_('File not versioned'),
+            error_dialog(_('File not versioned'),
                                      _('The selected file is not versioned.'))
             return
-        except:
-            raise
         
         self.comm.refresh_right()
 
@@ -185,7 +177,7 @@
         filename = self.comm.get_selected_right()
         
         if filename is None:
-            self.dialog.error_dialog(_('No file was selected'),
+            error_dialog(_('No file was selected'),
                                      _('Please select a file from the list,\nor choose the other option.'))
             return
 
@@ -204,22 +196,23 @@
     def commit(self, action):
         """ Right context menu -> Commit """
         from commit import OliveCommit
-        commit = OliveCommit(self.gladefile, self.comm, self.dialog)
+        wt, path = WorkingTree.open_containing(self.comm.get_path())
+        commit = OliveCommit(wt, path)
         commit.display()
     
     def diff(self, action):
         """ Right context menu -> Diff """
         from diff import OliveDiff
-        diff = OliveDiff(self.gladefile, self.comm, self.dialog)
+        diff = OliveDiff(self.comm)
         diff.display()
     
     def bookmark(self, action):
         """ Right context menu -> Bookmark """
         if self.comm.pref.add_bookmark(self.comm.get_path()):
-            self.dialog.info_dialog(_('Bookmark successfully added'),
+            info_dialog(_('Bookmark successfully added'),
                                     _('The current directory was bookmarked. You can reach\nit by selecting it from the left panel.'))
         else:
-            self.dialog.warning_dialog(_('Location already bookmarked'),
+            warning_dialog(_('Location already bookmarked'),
                                        _('The current directory is already bookmarked.\nSee the left panel for reference.'))
         
         self.comm.refresh_left()
@@ -229,7 +222,7 @@
         from bookmark import OliveBookmark
 
         if self.comm.get_selected_left() != None:
-            bookmark = OliveBookmark(self.gladefile, self.comm, self.dialog)
+            bookmark = OliveBookmark(self.comm)
             bookmark.display()
 
     def remove_bookmark(self, action):
@@ -253,5 +246,5 @@
     def diff_all(self, action):
         """ Diff toolbutton -> All... """
         from diff import OliveDiff
-        diff = OliveDiff(self.gladefile, self.comm, self.dialog)
+        diff = OliveDiff(self.comm)
         diff.display()

=== modified file 'olive/mkdir.py'
--- olive/mkdir.py	2006-09-05 01:55:34 +0000
+++ olive/mkdir.py	2006-09-27 19:52:46 +0000
@@ -22,25 +22,19 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
 
 import bzrlib.errors as errors
 
+from olive import gladefile
+
 class OliveMkdir:
     """ Display the Make directory dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, wt, wtpath):
         """ Initialize the Make directory dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_mkdir', 'olive-gtk')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_mkdir', 'olive-gtk')
         
         self.window = self.glade.get_widget('window_mkdir')
         
@@ -63,37 +57,34 @@
         dirname = entry.get_text()
         
         if dirname == "":
-            self.dialog.error_dialog(_('No directory name given'),
+            error_dialog(_('No directory name given'),
                                      _('Please specify a desired name for the new directory.'))
             return
         
-        newdir = self.comm.get_path() + '/' + dirname
-        
         if checkbox.get_active():
             # Want to create a versioned directory
             try:
                 from bzrlib.workingtree import WorkingTree
     
-                os.mkdir(newdir)
+                os.mkdir(os.path.join(wt.base, wtpath))
 
-                wt, dd = WorkingTree.open_containing(newdir)
-                wt.add([dd])
+                wt.add([wtpath])
             except OSError, e:
                 if e.errno == 17:
-                    self.dialog.error_dialog(_('Directory already exists'),
+                    error_dialog(_('Directory already exists'),
                                              _('Please specify another name to continue.'))
                 else:
                     raise
             except errors.NotBranchError:
-                self.dialog.warning_dialog(_('Directory is not in a branch'),
+                warning_dialog(_('Directory is not in a branch'),
                                            _('You can only create a non-versioned directory.'))
         else:
             # Just a simple directory
             try:
-                os.mkdir(newdir)
+                os.mkdir(os.path.join(wt.base, wtpath))
             except OSError, e:
                 if e.errno == 17:
-                    self.dialog.error_dialog(_('Directory already exists'),
+                    error_dialog(_('Directory already exists'),
                                              _('Please specify another name to continue.'))
                     return
 

=== modified file 'olive/move.py'
--- olive/move.py	2006-09-05 01:55:34 +0000
+++ olive/move.py	2006-09-27 20:30:59 +0000
@@ -22,25 +22,22 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
 
 import bzrlib.errors as errors
 
+from olive import gladefile
+
 class OliveMove:
     """ Display the Move dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, comm):
         """ Initialize the Move dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_move', 'olive-gtk')
+        self.glade = gtk.glade.XML(gladefile, 'window_move', 'olive-gtk')
         
         # Communication object
         self.comm = comm
-        # Dialog object
-        self.dialog = dialog
         
         self.window = self.glade.get_widget('window_move')
         
@@ -65,7 +62,7 @@
         filename = self.comm.get_selected_right()
             
         if filename is None:
-            self.dialog.error_dialog(_('No file was selected'),
+            error_dialog(_('No file was selected'),
                                      _('Please select a file from the list to proceed.'))
             return
         
@@ -76,13 +73,13 @@
             wt1, path1 = WorkingTree.open_containing(source)
             wt2, path2 = WorkingTree.open_containing(destination)
             if wt1.base != wt2.base:
-                self.dialog.error_dialog(_('Not the same branch'),
+                error_dialog(_('Not the same branch'),
                                          _('The destination is not in the same branch.'))
                 return
 
             wt1.move([source], destination)
         except errors.NotBranchError:
-            self.dialog.error_dialog(_('File is not in a branch'),
+            error_dialog(_('File is not in a branch'),
                                      _('The selected file is not in a branch.'))
             return
 

=== modified file 'olive/push.py'
--- olive/push.py	2006-09-25 02:15:59 +0000
+++ olive/push.py	2006-09-28 06:35:56 +0000
@@ -21,28 +21,24 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.gdk
-    import gtk.glade
-except:
-    sys.exit(1)
+    
+import gtk
+import gtk.gdk
+import gtk.glade
 
 import bzrlib.errors as errors
 
+from olive import gladefile
+
 class OlivePush:
     """ Display Push dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, branch):
         """ Initialize the Push dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_push')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_push')
         
         self.window = self.glade.get_widget('window_push')
+
+        self.branch = branch
         
         # Dictionary for signal_autoconnect
         dic = { "on_button_push_push_clicked": self.push,
@@ -69,28 +65,13 @@
         self.entry_location.set_sensitive(0)
         self.check_remember.set_sensitive(0)
         self.check_create.set_sensitive(0)
-		
-        # Get stored location
-        self.notbranch = False
-        try:
-            from bzrlib.branch import Branch
-    
-            branch = Branch.open_containing(self.comm.get_path())[0]
-    
-            self.entry_stored.set_text(branch.get_push_location())
-        except errors.NotBranchError:
-            self.notbranch = True
-            return
+        
+        self.entry_stored.set_text(branch.get_push_location())
     
     def display(self):
         """ Display the Push dialog. """
-        if self.notbranch:
-            self.dialog.error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
-            self.close()
-        else:
-            self.window.show()
-            self.width, self.height = self.window.get_size()
+        self.window.show()
+        self.width, self.height = self.window.get_size()
     
     def stored_toggled(self, widget):
         if widget.get_active():
@@ -118,51 +99,41 @@
     
     def push(self, widget):
         revs = 0
-        self.comm.set_busy(self.window)
         if self.radio_stored.get_active():
             try:
-                revs = do_push(self.comm.get_path(),
+                revs = do_push(self.branch,
                                overwrite=self.check_overwrite.get_active())
             except errors.NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
+                error_dialog(_('Directory is not a branch'),
                                          _('You can perform this action only in a branch.'))
                 return
             except errors.DivergedBranches:
-                self.dialog.error_dialog(_('Branches have been diverged'),
+                error_dialog(_('Branches have been diverged'),
                                          _('You cannot push if branches have diverged. Use the\noverwrite option if you want to push anyway.'))
                 return
-            except:
-                raise
         elif self.radio_specific.get_active():
             location = self.entry_location.get_text()
             if location == '':
-                self.dialog.error_dialog(_('No location specified'),
+                error_dialog(_('No location specified'),
                                          _('Please specify a location or use the default.'))
                 return
             
             try:
-                revs = do_push(self.comm.get_path(), location,
+                revs = do_push(self.branch, location,
                                self.check_remember.get_active(),
                                self.check_overwrite.get_active(),
                                self.check_create.get_active())
             except errors.NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
+                error_dialog(_('Directory is not a branch'),
                                          _('You can perform this action only in a branch.'))
-                self.comm.set_busy(self.window, False)
                 return
             except errors.DivergedBranches:
-                self.dialog.error_dialog(_('Branches have been diverged'),
+                error_dialog(_('Branches have been diverged'),
                                          _('You cannot push if branches have diverged. Use the\noverwrite option if you want to push anyway.'))
-                self.comm.set_busy(self.window, False)
                 return
-            except:
-                raise
-        else:
-            # This should really never happen
-            pass
         
         self.close()
-        self.dialog.info_dialog(_('Push successful'),
+        info_dialog(_('Push successful'),
                                 _('%d revision(s) pushed.') % revs)
     
     def test(self, widget):
@@ -219,7 +190,7 @@
     stored_loc = br_from.get_push_location()
     if location is None:
         if stored_loc is None:
-            self.dialog.error_dialog(_('Push location is unknown'),
+            error_dialog(_('Push location is unknown'),
                                      _('Please specify a location manually.'))
             return
         else:
@@ -244,7 +215,7 @@
                 relurl = transport.relpath(location_url)
                 transport.mkdir(relurl)
             except errors.NoSuchFile:
-                self.dialog.error_dialog(_('Non existing parent directory'),
+                error_dialog(_('Non existing parent directory'),
                                          _("The parent directory (%s)\ndoesn't exist.") % location)
                 return
         else:
@@ -260,7 +231,7 @@
                     needed.append((new_transport,
                                    new_transport.relpath(transport.base)))
                     if new_transport.base == transport.base:
-                        self.dialog.error_dialog(_('Path prefix not created'),
+                        error_dialog(_('Path prefix not created'),
                                                  _("The path leading up to the specified location couldn't\nbe created."))
                         return
         dir_to = br_from.bzrdir.clone(location_url,
@@ -270,18 +241,15 @@
     else:
         old_rh = br_to.revision_history()
         try:
-            try:
-                tree_to = dir_to.open_workingtree()
-            except errors.NotLocalUrl:
-                # FIXME - what to do here? how should we warn the user?
-                #warning('This transport does not update the working '
-                #        'tree of: %s' % (br_to.base,))
-                count = br_to.pull(br_from, overwrite)
-            except errors.NoWorkingTree:
-                count = br_to.pull(br_from, overwrite)
-            else:
-                count = tree_to.pull(br_from, overwrite)
-        except errors.DivergedBranches:
-            raise
-    
+            tree_to = dir_to.open_workingtree()
+        except errors.NotLocalUrl:
+            # FIXME - what to do here? how should we warn the user?
+            #warning('This transport does not update the working '
+            #        'tree of: %s' % (br_to.base,))
+            count = br_to.pull(br_from, overwrite)
+        except errors.NoWorkingTree:
+            count = br_to.pull(br_from, overwrite)
+        else:
+            count = tree_to.pull(br_from, overwrite)
+
     return count

=== modified file 'olive/remove.py'
--- olive/remove.py	2006-09-25 01:58:44 +0000
+++ olive/remove.py	2006-09-27 21:05:19 +0000
@@ -20,27 +20,21 @@
     import pygtk
     pygtk.require("2.0")
 except:
-    pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+	pass
+
+import gtk
+import gtk.glade
 
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
+from olive import gladefile
+
 class OliveRemove:
     """ Display the Remove file(s) dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self):
         """ Initialize the Remove file(s) dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_remove')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_remove')
         
         self.window = self.glade.get_widget('window_remove')
         
@@ -61,58 +55,44 @@
         
         directory = self.comm.get_path()
         
-        self.comm.set_busy(self.window)
         if radio_selected.get_active():
             # Remove only the selected file
             filename = self.comm.get_selected_right()
             
             if filename is None:
-                self.dialog.error_dialog(_('No file was selected'),
+                error_dialog(_('No file was selected'),
                                          _('Please select a file from the list,\nor choose the other option.'))
-                self.comm.set_busy(self.window, False)
                 return
             
             try:
                 wt, path = WorkingTree.open_containing(directory + '/' + filename)
                 wt.remove(path)
             except errors.NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
+                error_dialog(_('Directory is not a branch'),
                                          _('You can perform this action only in a branch.'))
-                self.comm.set_busy(self.window, False)
                 return
             except errors.NotVersionedError:
-                self.dialog.error_dialog(_('File not versioned'),
+                error_dialog(_('File not versioned'),
                                          _('The selected file is not versioned.'))
-                self.comm.set_busy(self.window, False)
                 return
-            except:
-                raise
         elif radio_new.get_active():
             # Remove added files recursively
             try:
                 wt, path = WorkingTree.open_containing(directory)
             except errors.NotBranchError:
-                self.dialog.error_dialog(_('Directory is not a branch'),
+                error_dialog(_('Directory is not a branch'),
                                          _('You can perform this action only in a branch.'))
-                self.comm.set_busy(self.window, False)
                 return
-            except:
-                raise
             
             added = wt.changes_from(wt.basis_tree()).added
             file_list = sorted([f[0] for f in added], reverse=True)
             if len(file_list) == 0:
                 dialog.warning_dialog(_('No matching files'),
                                       _('No added files were found in the working tree.'))
-                self.comm.set_busy(self.window, False)
                 return
             wt.remove(file_list)
-        else:
-            # This should really never happen.
-            pass
         
         self.close()
-        self.comm.refresh_right()
     
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'olive/rename.py'
--- olive/rename.py	2006-09-05 01:55:34 +0000
+++ olive/rename.py	2006-09-27 20:30:59 +0000
@@ -22,25 +22,20 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
 
 import bzrlib.errors as errors
 
 class OliveRename:
     """ Display the Rename dialog and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, comm):
         """ Initialize the Rename dialog. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_rename')
+        self.glade = gtk.glade.XML(gladefile, 'window_rename')
         
         # Communication object
         self.comm = comm
-        # Dialog object
-        self.dialog = dialog
         
         self.window = self.glade.get_widget('window_rename')
         
@@ -63,12 +58,12 @@
         new_filename = entry.get_text()
             
         if old_filename is None:
-            self.dialog.error_dialog(_('No file was selected'),
+            error_dialog(_('No file was selected'),
                                      _('Please select a file from the list to proceed.'))
             return
         
         if new_filename == "":
-            self.dialog.error_dialog(_('Filename not given'),
+            error_dialog(_('Filename not given'),
                                      _('Please specify a new name for the file.'))
             return
         
@@ -81,12 +76,12 @@
             wt2, path2 = WorkingTree.open_containing(source)
 
             if wt1.base != wt2.base:
-                self.dialog.error_dialog(_('Not the same branch'),
+                error_dialog(_('Not the same branch'),
                                          _('The destination is not in the same branch.'))
                 return
             wt1.rename_one(source, destination)
         except errors.NotBranchError:
-            self.dialog.error_dialog(_('File is not in a branch'),
+            error_dialog(_('File is not in a branch'),
                                      _('The selected file is not in a branch.'))
             return
 

=== modified file 'olive/status.py'
--- olive/status.py	2006-09-24 18:10:41 +0000
+++ olive/status.py	2006-09-28 06:35:56 +0000
@@ -21,58 +21,36 @@
     pygtk.require("2.0")
 except:
     pass
-try:
-    import gtk
-    import gtk.glade
-    import gobject
-    import pango
-except:
-    sys.exit(1)
+
+import gtk
+import gtk.glade
+import gobject
+import pango
 
 import bzrlib
 import bzrlib.errors as errors
 
-if bzrlib.version_info < (0, 9):
-    # function deprecated after 0.9
-    from bzrlib.delta import compare_trees
-
 from bzrlib.status import show_tree_status
 from bzrlib.workingtree import WorkingTree
 
-from dialog import OliveDialog
+from dialog import error_dialog
+
+from olive import gladefile
 
 class OliveStatus:
     """ Display Status window and perform the needed actions. """
-    def __init__(self, gladefile, comm, dialog):
+    def __init__(self, wt, wtpath):
         """ Initialize the Status window. """
-        self.gladefile = gladefile
-        self.glade = gtk.glade.XML(self.gladefile, 'window_status')
-        
-        # Communication object
-        self.comm = comm
-        # Dialog object
-        self.dialog = dialog
+        self.glade = gtk.glade.XML(gladefile, 'window_status')
         
         # Get the Status window widget
         self.window = self.glade.get_widget('window_status')
+        self.wt = wt
+        self.wtpath = wtpath
         
         # Check if current location is a branch
-        try:
-            (self.wt, path) = WorkingTree.open_containing(self.comm.get_path())
-            branch = self.wt.branch
-        except errors.NotBranchError:
-            self.notbranch = True
-            return
-        except:
-            raise
-        
-        file_id = self.wt.path2id(path)
+        file_id = self.wt.path2id(wtpath)
 
-        self.notbranch = False
-        if file_id is None:
-            self.notbranch = True
-            return
-        
         # Set the old working tree
         self.old_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
         
@@ -98,10 +76,7 @@
         column.add_attribute(cell, "text", 0)
         self.treeview.append_column(column)
         
-        if bzrlib.version_info < (0, 9):
-            delta = compare_trees(self.old_tree, self.wt)
-        else:
-            delta = self.wt.changes_from(self.old_tree)
+        delta = self.wt.changes_from(self.old_tree)
 
         changes = False
         
@@ -145,12 +120,7 @@
     
     def display(self):
         """ Display the Diff window. """
-        if self.notbranch:
-            self.dialog.error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
-            self.close()
-        else:
-            self.window.show_all()
+        self.window.show_all()
 
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'olive/ui.py'
--- olive/ui.py	2006-09-05 01:55:34 +0000
+++ olive/ui.py	2006-09-27 21:05:19 +0000
@@ -63,7 +63,7 @@
 
 
 class GtkUIFactory(UIFactory):
-    """A UI factory for GTK user interefaces."""
+    """A UI factory for GTK user interfaces."""
 
     def __init__(self,
                  bar_type=None,
@@ -91,10 +91,7 @@
         dialog = PromptDialog(prompt)
         response = dialog.run()
         dialog.destroy()
-        if response == gtk.RESPONSE_YES:
-            return True
-        else:
-            return False
+        return (response == gtk.RESPONSE_YES)
         
     @deprecated_method(zero_eight)
     def progress_bar(self):

